%% Copyright 2014 Keith Clark, Peter Robinson
%%
%% Licensed under the Apache License, Version 2.0 (the "License");
%% you may not use this file except in compliance with the License.
%% You may obtain a copy of the License at
%%
%%     http://www.apache.org/licenses/LICENSE-2.0
%%
%% Unless required by applicable law or agreed to in writing, software
%% distributed under the License is distributed on an "AS IS" BASIS,
%% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
%% See the License for the specific language governing permissions and
%% limitations under the License.

?- compile_time_only(consult(op_decls)).

?- dynamic('$random_seed'/1).
?- dynamic('__time__'/2).
?- dynamic('$builtin_type_descr'/2).

?- gettimeofday(T), assert('$start_time'(T)).
?- assert('$belief'(message_)).
?- dynamic(message_/3).
?- assert('$belief'(task_)).
?- dynamic(task_/2).
?- assert('$belief'(time_)).
?- assert('$belief'(running_)).
?- assert('$belief'(waiting_)).
?- assert('$belief'(resources_)).

%% +? mode is a postfix ? mode
?- assert('$user_type_info'(resources_hook, action, [], resources_hook, [])).
?- assert('$user_type_info'(message_, relation, ['+?'(term), handle, num],
			    message_(_, _, _), [])).
?- assert('$user_type_info'(checkBS_, action, [], checkBS_, [])).
?- assert('$user_type_info'(handle_message_, action,
                            ['+?'(term), '!'(robot_handle)],
                            handle_messsage_(_,_), [])).
?- assert('$user_type_info'(get_percepts_, action,
                            ['?'('$list_type'('+?'(term)))],
                            get_percepts_(_), [])).
?- assert('$user_type_info'(handle_percepts_, action,
                            ['!'('$list_type'(term))],
                            handle_percepts_(_), [])).
?- assert('$user_type_info'(mod_controls_, relation,
                            ['!'('$list_type'(control_action_)),
                             '?'('$list_type'(control_action_))],
                            mod_controls_(_,_), [])).
?- assert('$user_type_info'(send_robotic_message_, action,
                            ['!'(robot_message_)],
                            send_robotic_message_(_), [])).

?- assert('$builtin_type_descr'(now,"Returns Unix epoch time as a number of seconds\n")).


?- assert('$builtin_type_descr'(exec_time,"Returns lapsed time in secs since qulog process was forked.\n")).
 ?- assert('$builtin_type_descr'(start_time,"Returns now() value when the qulog process was started.\n")).


?- assert('$builtin_type_descr'(hand_shake_,"Type of the pair of atom messages sent by a TeleoR agents to\n    % a robotic interface to initiate and terminate control\n")).
?- assert('$builtin_type_descr'(control_action_,"Action controls which are  wrapped durative and discrete\n    % actions sent by TeleoR agents to a robotic interface\n")).
?- assert('$builtin_type_descr'(control_message_,"The  single message containing list of  control_actions_ sent\n    % by TeleoR agents\n")).
?- assert('$builtin_type_descr'(robot_message_,"Union of hand_shake_ and control_message_ types\n")).
?- assert('$builtin_type_descr'(actions,"Interpreter command that can be used in teleor mode when an agent \n    % has been started using start_agent. It is followed by a list\n    % of actions that agent wants the robotic interface to perform. \n    %  The given actions must have been declared as discrete or durative.\n")).

?- assert('$builtin_type_descr'(bottom,"Bottom of type hierarchy, bottom_ value indicate    %s undefined\n")).

?- assert('$builtin_type_descr'(task_,"Dynamic relation remembered and forgotten by start_task and kill_task.\n    % The atom is task name, the trcall is the TeleoR procedure call of task.\n")).

?- assert('$builtin_type_descr'(start_agent,"Command that can be used only in teleor extension of qulog. \n    % First arg. is agent name, second is handle of the robot interface or\n    % simulation with which the agent will interact, and the third argument\n    % is percepts update convention being used: all, updates or user.\n")).

?- assert('$builtin_type_descr'(start_task, "Starts a new task named by the atom arg.  executing the TeleoR\n    % call denoted by the trcall arg.\n")).

?- assert('$builtin_type_descr'(task_,"Dynamic relation remembered by start_task and forgotten by kill_task.\n Atom arg. is task name, trcall arg is term denoting the TeleoR procedure\n call it is executing.\n")). 

?- assert('$builtin_type_descr'(string2term,"The first argument must be a string comprtrising the character sequence\n    % of a QuLog term. The second argument is unified with that term.\n")).

?- assert('$builtin_type_descr'(readT, "Unifies its argument with the next term denoted by the next sequence\n    % of characters  typed at the terminal followed by fullstop, return.\n")).

?- assert('$builtin_type_descr'(set_default_message_thread,"Changes the destination of messages sent to this agent/process without\n    % a thread identification, to the thread named by the atom arg.\n")). 

?- assert('$builtin_type_descr'(remember,"Adds its ground relcall argument as a new last dynamic fact for its\n    % functor relation name R. R must have been declared as a belief.\n")).

?- assert('$builtin_type_descr'(rememberA,"Adds its ground relcall argument as a first last dynamic fact for its \n    % functor relation name R. R must have been declared as a belief.\n")).

?- assert('$builtin_type_descr'(remember_for,"Adds its ground relcall argument as a new last dynamic fact for its \n    % functor relation name R. R must have been declared as a belief.\n    % Fact is forgotten after the number of secs. of second arg.\n")).

?- assert('$builtin_type_descr'(rememberA_for,"Adds its ground relcall argument as a new first dynamic fact for its\n    % functor relation name R. R must have been declared as a belief.\n    % Fact is forgotten after the number of secs. of second arg.\n")).

?- assert('$builtin_type_descr'(replace_by,"Replaces the fact denoted by the first relcall argument\n    % by fact denoted by the second. They may share variables.\n")). 

?- assert('$builtin_type_descr'(write_type_nl__,"The atom that indicates a newline in argument list\n    % of the writeL and writeLine actions\n")).

?- assert('$builtin_type_descr'(write_type__,"The union type of all layout terms for use in  \n    % argument list of writeL and writeLine actions\n")).

?- assert('$builtin_type_descr'(write_type_other__,"The compound layout terms that can be used in argument\n    % list of writeL and writeLine actions\n")).

?- assert('$builtin_type_descr'(from,"Message receive action. Will succeed if there is a message term \n    % unifying with the term argument from an agent or thread unifying with \n    % the handle argument in executung threads message buffer. Will suspend and \n    % be repeatedly retried as new messages arrive until it succeeds.\n")). 

?- assert('$builtin_type_descr'(to,"Message send action. Sends the term first argument to the thread of agent \n    % given by the handle second argument.\n")). 


?- assert('$builtin_type_descr'(writeL,"Primitive action for displaying a list of terms to stdout\n    % with layout controlled using write_type_ descriptors.\n")).

?- assert('$builtin_type_descr'(writeLine,"Same as writeL action except always followed by a newline.\n")).
?- assert('$builtin_type_descr'(fork_as,"fork_as(Act,Name) creates a new thread named Name executing\n    % the action call Act. Can be written: fork Act as Name\n    % Name must be new thread name if given.\n")).

?- assert('$builtin_type_descr'(current_thread,"Checks the name of thread executing the call is given atom arg.\n")).

?- assert('$builtin_type_descr'(call,"QuLog meta-relation-call prefix operator. Will call the relation named by \n    % functor of relcall arg. with call arguments those of the relcall term.\n    % Will fail if a required ground argument is not ground.\n")).

?- assert('$builtin_type_descr'(do,"QuLog prefix meta-action-call. Will call the action named by \n    % functor of actcal larg. with arguments those of the actcall term.\n    % Will fail if a required ground argument is not ground.\n")).

?- assert('$builtin_type_descr'(ground,"Succeeds only if its term argument contains no unbound variables.\n")).

?- assert('$builtin_type_descr'(ground_inputs,"Succeeds only if its relcall or actcall term argument has ground arguments\n    % where these have been specified in the named rel or act. type declaration\n")).

?- assert('$builtin_type_descr'(in,"Multi-purpose infix membership operator for retrieving or testing\n    % membersip of lists, sets and strings.\n")). 

?- assert('$builtin_type_descr'(inter,"Infix operator for finding intersection of two sets.\n")).
?- assert('$builtin_type_descr'(union,"Infix operator for finding union of two sets.\n")).
?- assert('$builtin_type_descr'(diff,"Infix operator for finding elements of first set arg. not in the second.\n")).

?- assert('$builtin_type_descr'(# ,"Operator that returns the length of a list or string or the size of a set\n")).
?- assert('$builtin_type_descr'($,"Operator that returns numeric  value linked with an atom name\n")).
?- assert('$builtin_type_descr'(*,"Infix multiplication operator - left associative\n")).
?- assert('$builtin_type_descr'(**,"Infix exponentiation operator - not associative\n")).
?- assert('$builtin_type_descr'(+,"Infix addition operator - left associative\n")).
?- assert('$builtin_type_descr'(-,"Infix subtraction operator - left associative\n    % and number complement prefix operator\n")).
?- assert('$builtin_type_descr'(/,"Infix division operator - left associative\n    % Note it always returns a floating point number\n    % Use // for integer division returning an integer\n")).
?- assert('$builtin_type_descr'(//,"Infix integer division operator - left associative\n    % Returns integer part of the division operation\n")).
?- assert('$builtin_type_descr'(\/,"Infix integer bitwise OR operator - left associative\n")).
?- assert('$builtin_type_descr'(/\,"Infix, integer bitwise AND operator - left associative\n")).
?- assert('$builtin_type_descr'(\,"Prefix, returns integer that is the bitwise complement\n    % of the argument integer\n")).
?- assert('$builtin_type_descr'(+:=,"Increment number associated with LHS atom by RHS value\n")).
?- assert('$builtin_type_descr'(-:=,"Decrement number associated with LHS atom by RHS value\n")).
?- assert('$builtin_type_descr'(:=,"Change number associated with LHS atom by RHS value\n")).
?- assert('$builtin_type_descr'(<<,"Shift bits of integer first arg. left by pos integer of second\n")).
?- assert('$builtin_type_descr'(>>,"Shift bits of integer first arg. right by pos integer of second\n")).

?- assert('$builtin_type_descr'(<>,"Infix left associative operator which is both a function for appending a pair\n    %  of complete lists and a pattern operator for use\n    %  on LHS of =? for non-deterministically splitting a list.\n")).

?- assert('$builtin_type_descr'(++,"Infix left associative operator which is both a function for \n    % concatenating a pair of strings and a pattern operator for use on\n    %  LHS of =? for non-deterministically splitting strings.\n")).

?- assert('$builtin_type_descr'(<,"Numeric values, less than\n")).
?- assert('$builtin_type_descr'(>,"Numeric values, greater than\n")).
?- assert('$builtin_type_descr'(=<,"Numeric values, less than or equal\n")).
?- assert('$builtin_type_descr'(>=,"Numeric values, greater than or equal\n")).
?- assert('$builtin_type_descr'(@<,"QuLog term ordering, less than\n")).
?- assert('$builtin_type_descr'(@>,"QuLog term ordering, greater than\n")).
?- assert('$builtin_type_descr'(@=<,"QuLog term ordering, less than or equal\n")).
?- assert('$builtin_type_descr'(@=,"QuLog term ordering, identical terms, same as ==\n")).
?- assert('$builtin_type_descr'(@>=,"QuLog term ordering, greater than or equal\n")).
?- assert('$builtin_type_descr'(=,"Any terms, unification with occurs check\n")).
?- assert('$builtin_type_descr'(\=,"Any terms, unification fails with occurs check\n")).

?- assert('$builtin_type_descr'(handle,"All the different address formats of a thread for communication\n")).

?- assert('$builtin_type_descr'(pedro_handle,"Address format for communication to a specific thread of an\n    % agent or QuLog process on the atom named host\n")).


?- assert('$builtin_type_descr'(thread_in_process,"Address format for communication to another thread of an\n    % agent or QuLog process on same host\n")).

?- assert('$builtin_type_descr'(agent_handle,"Address format for communication to initial thread of another\n    % agent or process on named host\n")).

?- assert('$builtin_type_descr'(dynamic,"Union of TeleoR program defined percept and belief types\n")).

?- assert('$builtin_type_descr'(ceiling,"Returns the smallest integer greater than number arg.\n")).
?- assert('$builtin_type_descr'(floor,"Returns the greatest integer less than the number arg.\n")).
?- assert('$builtin_type_descr'(round,"Returns the nearest integer to number argument.\n")).

?- assert('$builtin_type_descr'(false,"Relation call that always immediately fails. \n")).
?- assert('$builtin_type_descr'(true,"Relation call that always immediately succeeds. \n")).

?- assert('$builtin_type_descr'(fail, "Action that has no definition.\n")).

?- assert('$builtin_type_descr'(forget,"Action that will remove first dynamic fact matching its argument.\n")).

?- assert('$builtin_type_descr'(forget_after,"Action that will remove first dynamic fact matching its argument\n    % after given number of secs.\n")).

?- assert('$builtin_type_descr'(get_active_resources,"May be used to find list of terms res(atom,[resource]) giving resources \n    % used by each running task in a multi-tasking agent. The atom is task name.\n")).

?- assert('$builtin_type_descr'(get_waiting_resources,"May be used to find a list of terms res(atom,[resource]) giving resources \n    % needed  by each waiting task in a multi-tasking agent. The atom is task name.\n")).

?- assert('$builtin_type_descr'(waiting_,"Dynamic belief maintained by TeleoR runtime system to record\n    % the list of resources needed by a waiting task. The num arg. is\n    % the time at which the task started waiting for resources.\n")). 

?- assert('$builtin_type_descr'(runing_,"Dynamic belief maintained by TeleoR runtime system to record\n    % the list of resources being used by a running task. \n")). 


?- assert('$builtin_type_descr'(isa,"Can be used to check or generate instances of the type\n    % described by second argument providing this a finite number of\n    % ground instances.\n")). 

?- assert('$builtin_type_descr'(type,"Can be used to check if a value has the type described by type \n    % the expression second argument. As a top level QuLog query \n    % can be used to find the type of a value.\n")). 

?- assert('$builtin_type_descr'(typeC,"Can be used only as a top level QuLog query to check if a value \n    % has the type described by type expression second argument.\n    % The third argument should be a variable. It will be bound to a \n    % list of type constraints for any vars in the given value.\n")). 


?- assert('$builtin_type_descr'(kill_agent,"Kills current agent started using start_agent. May only\n    % be used in the teleor extension of QuLog.\n")).

?- assert('$builtin_type_descr'(kill_task,"Kills named task started using start_task. May only\n    % be used in the teleor extension of QuLog.\n")).

?- assert('$builtin_type_descr'(not,"Negation-as-failure condition. The only unbound variables allowed\n    % in the relcall are anonymous _ underscore vars.\n")).


?- assert('$builtin_type_descr'(log,"Returns natural log value.\n")).
?- assert('$builtin_type_descr'(mod,"mod(M,N) is remainder of integer division of M by N.\n    % Can be used as infix operator.\n")).
?- assert('$builtin_type_descr'(e_,"Returns the value of arithmentic constant 'e'\n")).
?- assert('$builtin_type_descr'(pi_,"Returns the value of arithmentic constant 'pi'\n")).
?- assert('$builtin_type_descr'(log,"The natural log value of the argument.\n")).
?- assert('$builtin_type_descr'(sqrt,"Returns square root of argument.\n")).
?- assert('$builtin_type_descr'(sum,"Returns sum of nums on num list argument.\n")).
?- assert('$builtin_type_descr'(prod,"Returns product of nums on num list argument.\n")).
?- assert('$builtin_type_descr'(random_num,"Returns a random number between 0 and 1 inclusive.\n")).
?- assert('$builtin_type_descr'(random_int,"random_int(M,N) returns a random integer between M and N inclusive.\n")).


?- assert('$builtin_type_descr'(sort,"Will unify second argument list pattern with @< ordered version \n    % of the first argument list of terms, with duplicates removed.\n")). 

?- assert('$builtin_type_descr'(abs,"Returns the absolute value of number arg.\n")).
?- assert('$builtin_type_descr'(cos,"Returns the cosine of radian value argument\n")).
?- assert('$builtin_type_descr'(sin,"Returns the sine of radian value argument\n")).
?- assert('$builtin_type_descr'(tan,"Returns the tangent of radian value argument\n")).
?- assert('$builtin_type_descr'(abs,"Returns the absolute value of number arg.\n")).
?- assert('$builtin_type_descr'(acos,"Inverse cosine function\n")).
?- assert('$builtin_type_descr'(asin,"Inverse sine function\n")).
?- assert('$builtin_type_descr'(atan,"Inverse tangent function\n")).
?- assert('$builtin_type_descr'(atan2,"atan2(y, x) is the angle in radians between the\n    % positive x-axis of a plane and the point  (x, y).\n    % Value is positive for  y > 0), negative for y < 0\n")).

?- assert('$builtin_type_descr'(=?,"Pattern match operator. LHS must be or evaluate to  a ground data  term. \n    % RHS can evaluate to a template term, or be a @.. , ++ , <> pattern\n")).

?- assert('$builtin_type_descr'(@..,"Infix operator that can be used as a function to construct\n    % a compund F(A1,..,An) with a call F@[A1,..,Ak] or as a pattern\n    % on RHS of =? to do the reverse mapping of a given LHS compound term.\n")).

?- assert('$builtin_type_descr'(append,"Similar to the <> operator except it can be used\n    % with partial lists that have ,..Var undetermined tails.\n")).
?- assert('$builtin_type_descr'(member,"Similar to the 'in' operator except it can be used\n    % with partial lists that have ,..Var undetermined tails.\n")).
?- assert('$builtin_type_descr'(reverse,"Can be used to reverse a complete list of template\n    % terms.  Second argument can be list pattern using ,..\n")).

?-assert('$builtin_type_descr'(template,"Tests that its term argument is a compound term with non-variable constructor.\n")).

?-assert('$builtin_type_descr'(thread_sleep,"Causes the executing thread to suspend for given number of seconds.\n")).

?-assert('$builtin_type_descr'(time_,"Dynamic belief maintained by default agent's percept and message handlers.\n    % It always records the time of the most recent belief store update.\n")).



'$supress_show_type'(checkBS_, 0).
'$supress_show_type'(resources_hook, 0).
'$supress_show_type'(handle_message_, 2).
'$supress_show_type'(message_, 3).
'$supress_show_type'(mod_controls_, 2).
'$supress_show_type'('$list2set', 2).


'$supress_builtin_type'('$list2set').
'$supress_builtin_type'('$list_constr').
'$supress_builtin_type'('$set').
'$supress_builtin_type'('$set2list').
'$supress_builtin_type'('$time_').
'$supress_builtin_type'('$set_enum').
'$supress_builtin_type'('$unify').
'$supress_builtin_type'(type_info).

'$supress_defined_type'(type_kind_).

'$should_suppress_show_type'(G) :-
    '$supress_show_type'(G, N),
    \+current_predicate(G/N).

open_qulog_file(File, Mode, Stream) :-
    concat_atom([File, '.qlg'], QlgFile),
    '$accessible'(QlgFile), !,
    open(QlgFile, Mode, Stream).

open_qulog_file(File, _Mode, _Stream) :-
	exception(permission_error(unrecoverable, qconsult(File), default)).

readT(T) :- read_qulog_term(T1), T = T1.

answers(N) :-
    retract('$num_solutions'(_)),
    assert('$num_solutions'(N)).

'#'(T, N) :- string(T), !, string_length(T, N).
'#'('$set'(T), N) :- !, length(T, N).
'#'(T, N) :- closed_list(T), length(T, N).

in(A, B) :-
    string(B), !,
    sub_string(B, _Start, Len, _, A), Len = 1.

in(A, '$set'(B)) :- !, member(A, B).
in(A, B) :- closed_list(B), member(A, B).

typeG(A, B) :- ground(A), type(A, B).

isa(Term, Type) :-
    Type == dynamic, !,
    (
     isa(Term, belief)
    ;
     isa(Term, percept)
    ).
isa(Term, Type) :-
    Type == belief, !,
    '$belief_type_info'(_, _, Term),
    call(Term).
isa(Term, Type) :-
    freeze_term(Term),
    '$belief_type_info'(_, _, Term), !, Type = belief,
    thaw_term(Term),
    call(Term).
isa(Term, Type) :-
    Type == percept, !,
    '$percept_type_info'(_, _, Term),
    call(Term).
isa(Term, Type) :-
    freeze_term(Term),
    '$percept_type_info'(_, _, Term), !, Type = percept,
    thaw_term(Term),
    call(Term).
isa(Term, Type) :-
    '$type_info'(_, defined_type, Type, '$union_type'(UType), _),
    member(T, UType),
    isa(Term, T).
isa(Term, Type) :-
    '$type_info'(_, defined_type, Type, '$type_macro'(TypeM), _), !,
    isa(Term, TypeM).
isa(Term, Type) :-
    '$type_info'(_, defined_type, Type, '$enum_type'(TypeE), _), !,
    member(Term, TypeE).
isa(Term, Type) :-
    '$defined_type'(Type, (N..M)), !, between(N, M,  Term).
isa(Term, Type) :-
    '$type_info'(_, defined_type, Type, '$constr_enum_type'(UType), _),
    '$non_param_recursive'(Type, UType, []), !,
    member(UT, UType),
    functor(UT, F, N),
    length(Args, N),
    T =..[F|Args],
    UT =.. [_|UTArgs],
    map(isa, Args, UTArgs),
    Term = T.

'$non_param_recursive'(Type, _UType, _Seen) :-
    compound(Type), !, fail.
'$non_param_recursive'(_Type, UType, Seen) :-
    forall(member(UT, UType), '$finite_type'(UT, Seen)).

%%'$finite_type'(Type, Seen) :- errornl('$finite_type'(Type, Seen)), fail.
'$finite_type'(Type, _) :-
    '$type_info'(_, defined_type, Type, '$union_type'(_), _), !.
'$finite_type'(Type, Seen) :-
    '$type_info'(_, defined_type, Type, '$type_macro'(TM), _), !,
    '$finite_type'(TM, Seen).
'$finite_type'(Type, _) :-
    '$type_info'(_, defined_type, Type, '$enum_type'(_), _), !.
'$finite_type'(Type, _) :-
    '$defined_type'(Type, (_N.._M)), !.
'$finite_type'(Type, Seen) :-
    '$type_info'(_, defined_type, Type, '$constr_enum_type'(CT), _), !,
    '$non_param_recursive'(Type, CT, Seen).
'$finite_type'(Type, Seen) :-
    compound(Type), \+member(Type, Seen), !,
    Type =.. [_|Args],
    forall(member(A, Args), '$finite_type'(A, [Type|Seen])).


pi_(_, A) :- A is pi.
e_(_, A) :- A is e.
now(_, T) :- gettimeofday(T).
start_time(_, ST) :- '$start_time'(ST).
exec_time(_,ET) :- now(_, T), start_time(_, ST), ET is T - ST.

random_num(_, T) :- '$random_seed'(_), !, random(T).
random_num(_, T) :- srandom(S), assert('$random_seed'(S)), random(T).

random_int(N, M, T) :- '$random_seed'(_), !, random(N, M, T).
random_int(N, M, T) :- srandom(S), assert('$random_seed'(S)), random(N, M, T).

'$sum'([], B, B).
'$sum'([X|Xs], A, B) :-
    A1 is A + X,
    '$sum'(Xs, A1, B).
'$prod'([], B, B).
'$prod'([X|Xs], A, B) :-
    A1 is A * X,
    '$prod'(Xs, A1, B).

call_(G) :- ground_inputs(G), !, call(G).
call_(G) :- errornl(call_mode_error(G)), fail.

do_(G) :- ground_inputs(G), !, call(G).
do_(G) :- errornl(do_mode_error(G)), fail.


'#$apply'('#', T, N) :- '#'(T, N).
'in$apply'(in, A, B) :- in(A, B).

sum(A, B) :- '$sum'(A, 0, B).
prod(A, B) :- '$prod'(A, 1, B).
+(A,B,C) :- with_local_exception_handler(C is A + B, _, C = bottom_).
-(A,B,C) :- with_local_exception_handler(C is A - B, _, C = bottom_).
*(A,B,C) :- with_local_exception_handler(C is A * B, _, C = bottom_).
/(A,B,C) :- with_local_exception_handler(C is A / B, _, C = bottom_).
//(A,B,C) :- with_local_exception_handler(C is A // B, _, C = bottom_).
>>(A,B,C) :- with_local_exception_handler(C is A >> B, _, C = bottom_).
<<(A,B,C) :- with_local_exception_handler(C is A << B, _, C = bottom_).
mod(A,B,C) :- with_local_exception_handler(C is A mod B, _, C = bottom_).
'\\/'(A,B,C) :- with_local_exception_handler(C is A \/ B, _, C = bottom_).
'/\\'(A,B,C) :- with_local_exception_handler(C is A /\ B, _, C = bottom_).
**(A,B,C) :- with_local_exception_handler(C is A ** B, _, C = bottom_).
-(A, B) :- with_local_exception_handler(B is -A, _, B = bottom_).
'\\'(A, B) :- with_local_exception_handler(B is \A, _, B = bottom_).
sqrt(A, B) :- with_local_exception_handler(B is sqrt(A), _, B = bottom_).
sin(A, B) :- with_local_exception_handler(B is sin(A), _, B = bottom_).
cos(A, B) :- with_local_exception_handler(B is cos(A), _, B = bottom_).
tan(A, B) :- with_local_exception_handler(B is tan(A), _, B = bottom_).
asin(A, B) :- with_local_exception_handler(B is asin(A), _, B = bottom_).
acos(A, B) :- with_local_exception_handler(B is acos(A), _, B = bottom_).
atan(A, B) :- with_local_exception_handler(B is atan(A), _, B = bottom_).
round(A, B) :- with_local_exception_handler(B is round(A), _, B = bottom_).
floor(A, B) :- with_local_exception_handler(B is floor(A), _, B = bottom_).
ceiling(A, B) :- with_local_exception_handler(B is ceiling(A), _, B = bottom_).
log(A, B) :- with_local_exception_handler(B is log(A), _, B = bottom_).
abs(A, B) :- with_local_exception_handler(B is abs(A), _, B = bottom_).

atan2(Y,X,C) :- with_local_exception_handler('$atan2'(Y,X,C), _, C = bottom_).					 
'$atan2'(Y,0,C) :-
    Y > 0, !,
    C is pi/2.
'$atan2'(Y,0.0,C) :-
    Y > 0, !,
    C is pi/2.
'$atan2'(Y,0,C) :-
    Y < 0, !,
    C is -pi/2.
'$atan2'(Y,0.0,C) :-
    Y > 0, !,
    C is pi/2.
'$atan2'(Y,X,C) :- 
    X > 0, !,
    C is atan(Y/X).
'$atan2'(Y,X,C) :- 
    Y >= 0,
    C is pi + atan(Y/X).
'$atan2'(Y,X,C) :- 
    C is atan(Y/X) - pi.


'@..'(F, [], R) :- R= F('$none_').
'@..'(F, Args, R) :- R=..[F|Args].

'@..rev'(Compound, F, Args) :-
    \+list(Compound),
    compound(Compound),
    Compound =.. [F|Args1],
    (
      Args1 = ['$none_']
    ->
      Args = []
    ;
      Args = Args1
    ).

union(A, B, C) :-
    A = '$set'(A1),
    B = '$set'(B1),
    union_list(A1, B1, D1),
    sort(D1, C1), C = '$set'(C1).

inter(A, B, C) :-
    A = '$set'(A1),
    B = '$set'(B1),
    findall(X, (member(X, A1), member(X, B1)), D1),
    sort(D1, C1), C = '$set'(C1).

diff(A, B, C) :-
    A = '$set'(A1),
    B = '$set'(B1),
    findall(X, (member(X, A1), \+member(X, B1)), D1),
    sort(D1, C1), C = '$set'(C1).

template(X) :- atomic(X), !.
template(X) :-
    compound(X),
    functor(X, F, _),
    atom(F).

string2term(String, Term) :-
    string_concat(String, ".", StringDot),
    open_string(read(StringDot), Stream),
    with_local_exception_handler(read(Stream, Term), _, Term = bottom_).

'@..$apply'('@..', A, B) :- '@..'(A,B).
'sum$apply'('sum', A, B) :- sum(A,B).
'prod$apply'('prod', A, B) :- prod(A,B).
'<>$apply'('<>', (A,B), C) :- append(A,B,C).
'++$apply'('++', (A,B), C) :- string_concat(A,B,C).
'+$apply'('+', (A,B), C) :- +(A,B,C).
'*$apply'('*', (A,B), C) :- *(A,B,C).
'/$apply'('/', (A,B), C) :- /(A,B,C).
'//$apply'('//', (A,B), C) :- //(A,B,C).
'>>$apply'('>>', (A,B), C) :- >>(A,B,C).
'<<$apply'('<<', (A,B), C) :- <<(A,B,C).
'mod$apply'('mod', (A,B), C) :- mod(A,B,C).
'\\/$apply'('\\/', (A,B), C) :- '\\/'(A,B,C).
'/\\$apply'('/\\', (A,B), C) :- '/\\'(A,B,C).
'**$apply'('**', (A,B), C) :- **(A,B,C).
'-$apply'('-', (A,B), C) :- !, -(A,B,C).
'-$apply'('-', A, C) :- -(A,C).
'\\$apply'('\\', A, C) :- '\\'(A,C).
'sqrt$apply'('sqrt', A, C) :- sqrt(A,C).
'sin$apply'('sin', A, C) :- sin(A,C).
'cos$apply'('cos', A, C) :- cos(A,C).
'tan$apply'('tan', A, C) :- tan(A,C).
'asin$apply'('asin', A, C) :- asin(A,C).
'acos$apply'('acos', A, C) :- acos(A,C).
'atan$apply'('atan', A, C) :- atan(A,C).
'atan2$apply'('atan2', A, B, C) :- atan2(A,B, C).
'round$apply'('round', A, C) :- round(A,C).
'floor$apply'('floor', A, C) :- floor(A,C).
'ceiling$apply'('ceiling', A, C) :- ceiling(A,C).
'log$apply'('log', A, C) :- log(A,C).
'abs$apply'('abs', A, C) :- abs(A,C).

/*
  '$'(A, B) :- A(B).
':='(A, B) :- retract(A(_)), assert(A(B)).
':=+'(A, B) :-
    retract(A(N)),
    N1 is N+B,
    assert(A(N1)).
':=-'(A, B) :-
    retract(A(N)),
    N1 is N-B,
    assert(A(N1)).
*/

fork_as(Call, Name) :-
    thread_fork(Name, Call).
/*
fork_as(Call, Name) :-
    Call1 = (
              ip_set('$in_interpreter_query',false),
              ip_set('$global_vars', []),
              ip_set('$local_vars', []),
              ip_set('$underscore_vars', []),
              call(Call)
            ),
    thread_fork(Name, Call1).
*/

writeLine(Terms) :-
    writeL(Terms), nl.

to(Msg, Addr) :- Msg ->> Addr.
from(Msg, Addr) :- Msg <<= Addr.
    
apply(A, B, _C) :-
    atom(A), '$tuple2list'(B, BL),
    AC =.. [A|BL],
    '$type_info'(_, relation, _, AC, _), !,
    call(AC).
apply(A, B, C) :-
    '$generate_apply_name'(A, ApplyName),
    current_predicate(ApplyName/3), !,
    call(ApplyName(A, B, C)).
apply(A, B, A(B)).

match(A, A).
not_match(A, B) :- A \= B.
unify(A, A).
not_unify(A, B) :- A \= B.

not(A) :- \+ A.

time_(A) :- '__time__'(dummy, A).
running_(A) :- '__running__'(dummy, A).
waiting_(A) :- '__waiting__'(dummy, A).
resources_(A, R) :- '__resources__'(dummy, A, R).

typeC(A, B, C) :- type(A, B, C).

current_thread(Name) :- thread_symbol(Name1), Name = Name1.

%task_start(TR) :- functor(TR, TRF, _), '$task_start'(TRF).

'$builtin_type_info'('union', function,
                     ('$tuple_type'(['$set_type'(T),
                                '$set_type'(T)]) -> '$set_type'(T)),
                     '$function', [T='T']).
'$builtin_type_info'('diff', function,
                     ('$tuple_type'(['$set_type'(T),
                                '$set_type'(T)]) -> '$set_type'(T)),
                     '$function', [T='T']).
'$builtin_type_info'('inter', function,
                     ('$tuple_type'(['$set_type'(T),
                                '$set_type'(T)]) -> '$set_type'(T)),
                     '$function', [T='T']).
'$builtin_type_info'('pi_', function, ('$tuple_type'([]) -> num), '$function', []).
'$builtin_type_info'('e_', function, ('$tuple_type'([]) -> num), '$function', []).
'$builtin_type_info'('now', function, ('$tuple_type'([]) -> num), '$function', []).
'$builtin_type_info'('start_time', function, ('$tuple_type'([]) -> num),
                     '$function', []).
'$builtin_type_info'('exec_time', function, ('$tuple_type'([]) -> num),
                     '$function', []).
'$builtin_type_info'('sqrt', function, (num -> num), '$function', []).
'$builtin_type_info'('sin', function, (num -> num), '$function', []).
'$builtin_type_info'('cos', function, (num -> num), '$function', []).
'$builtin_type_info'('tan', function, (num -> num), '$function', []).
'$builtin_type_info'('asin', function, (num -> num), '$function', []).
'$builtin_type_info'('acos', function, (num -> num), '$function', []).
'$builtin_type_info'('atan', function, (num -> num), '$function', []).
'$builtin_type_info'('atan2', function, ('$tuple_type'([num, num]) -> num),
                     '$function', []).
'$builtin_type_info'('round', function, (num -> int), '$function', []).
'$builtin_type_info'('floor', function, (num -> int), '$function', []).
'$builtin_type_info'('ceiling', function, (num -> int), '$function', []).
'$builtin_type_info'('log', function, (num -> num), '$function', []).
'$builtin_type_info'('abs', function, (int -> nat), '$function', []).
'$builtin_type_info'('abs', function, (num -> num), '$function', []).
'$builtin_type_info'('-', function, (int -> int), '$function', []).
'$builtin_type_info'('-', function, (num -> num), '$function', []).
'$builtin_type_info'('+', function, ('$tuple_type'([nat, nat]) -> nat),
                     '$function', []).
'$builtin_type_info'('+', function, ('$tuple_type'([int, int]) -> int),
                     '$function', []).
'$builtin_type_info'('+', function, ('$tuple_type'([num, num]) -> num),
                     '$function', []).
'$builtin_type_info'('-', function, ('$tuple_type'([int, int]) -> int),
                     '$function', []).
'$builtin_type_info'('-', function, ('$tuple_type'([num, num]) -> num),
                     '$function', []).
'$builtin_type_info'('*', function, ('$tuple_type'([nat, nat]) -> nat),
                     '$function', []).
'$builtin_type_info'('*', function, ('$tuple_type'([int, int]) -> int),
                     '$function', []).
'$builtin_type_info'('*', function, ('$tuple_type'([num, num]) -> num),
                     '$function', []).
'$builtin_type_info'('**', function, ('$tuple_type'([nat, nat]) -> nat),
                     '$function', []).
'$builtin_type_info'('**', function, ('$tuple_type'([int, nat]) -> int),
                     '$function', []).
'$builtin_type_info'('**', function, ('$tuple_type'([num, num]) -> num),
                     '$function', []).
'$builtin_type_info'('/', function, ('$tuple_type'([num, num]) -> num),
                     '$function', []).
'$builtin_type_info'('//', function, ('$tuple_type'([nat, nat]) -> nat),
                     '$function', []).
'$builtin_type_info'('//', function, ('$tuple_type'([int, int]) -> int),
                     '$function', []).
'$builtin_type_info'('>>', function, ('$tuple_type'([int, nat]) -> int),
                     '$function', []).
'$builtin_type_info'('<<', function, ('$tuple_type'([int, nat]) -> int),
                     '$function', []).
'$builtin_type_info'('/\\', function, ('$tuple_type'([int, int]) -> int),
                     '$function', []).
'$builtin_type_info'('\\/', function, ('$tuple_type'([int, int]) -> int),
                     '$function', []). 
'$builtin_type_info'('\\', function, ('$tuple_type'([int]) -> int),
                     '$function', []). 
'$builtin_type_info'('mod', function, ('$tuple_type'([nat, int]) -> nat),
                     '$function', []).
'$builtin_type_info'('mod', function, ('$tuple_type'([int, int]) -> int),
                     '$function', []).
'$builtin_type_info'('$list2set', function, ('$list_type'(T) ->'$set_type'(T)),
                     '$function', [T='T']).
'$builtin_type_info'('$set2list', function, ('$set_type'(T) -> '$list_type'(T)),
                     '$function', [T='T']).
'$builtin_type_info'('$list_constr', function, ('$tuple_type'([T, term]) ->[T]),
                     '$function', [T='T']).
'$builtin_type_info'('$set', function,
                     ('$tuple_type'([T, term]) ->'$set_type'(T)),
                     '$function', [T='T']).
'$builtin_type_info'('$set_enum', function,
                     ('$list_type'(T) ->'$set_type'(T)),
                     '$function', [T='T']).
'$builtin_type_info'('#', function, ('$list_type'(_) -> nat), '$function', []).
'$builtin_type_info'('#', function, ('$set_type'(_) -> nat), '$function', []).
'$builtin_type_info'('#', function, (string -> nat), '$function', []).
'$builtin_type_info'('<>', function,
                     ('$tuple_type'(['$list_type'(T), '$list_type'(T)])
                     -> '$list_type'(T)),
                     '$function', [T='T']).
'$builtin_type_info'('++', function,
                     ('$tuple_type'([string, string]) -> string),
                     '$function', []).
'$builtin_type_info'('$', function, (('$tuple_type'([int]) <=) -> int),
                     '$function', []).
'$builtin_type_info'('$', function, (('$tuple_type'([num]) <=) -> num),
                     '$function', []).
'$builtin_type_info'(random_num, function, ('$tuple_type'([]) -> num),
                     '$function', []).
'$builtin_type_info'(random_int, function, ('$tuple_type'([int, int]) -> num),
                     '$function', []).
'$builtin_type_info'('sum', function, ('$list_type'(int) -> int),
                     '$function', []).
'$builtin_type_info'('sum', function, ('$list_type'(num) -> num),
                     '$function', []).
'$builtin_type_info'('prod', function, ('$list_type'(int) -> int),
                     '$function', []).
'$builtin_type_info'('prod', function, ('$list_type'(num) -> num),
                     '$function', []).
'$builtin_type_info'('@..', function,
                     ('$tuple_type'([term, '$list_type'(term)]) -> term),
                     '$function', []).


'$builtin_type_info'('=?', relation, ['!'(string), '?'(string)],
                     (_ '=?' _), []).
'$builtin_type_info'('=?', relation, ['!'('$list_type'(term)), '?'('$list_type'(term))], (_ '=?' _), []).
'$builtin_type_info'('=?', relation, ['!'(term), '?'(term)], (_ '=?' _), []).
'$builtin_type_info'('@=', relation, ['!'(term), '!'(term)], (_ @= _), []).
'$builtin_type_info'('=', relation, ['!'(T), '?'(T)], (_ = _), [T='T']).
'$builtin_type_info'('=', relation, ['?'(T), '!'(T)], (_ = _), [T='T']).
'$builtin_type_info'('=', relation, ['+?'(T), '+?'(T)], (_ = _), [T='T']).
'$builtin_type_info'('$unify', relation, ['+?'(T), '+?'(T)], '$unify'(_, _), [T='T']).
'$builtin_type_info'('\\=', relation, ['!'(term), '!'(term)], (_ \= _), []).
% '$builtin_type_info'('=:=', relation, ['!'(term), '!'(term)], (_ =:= _), []).
% '$builtin_type_info'('=\\=', relation, ['!'(term), '!'(term)], (_ =\= _), []).
'$builtin_type_info'('>', relation, ['!'(num), '!'(num)], (_ > _), []).
'$builtin_type_info'('<', relation, ['!'(num), '!'(num)], (_ < _), []).
'$builtin_type_info'('>=', relation, ['!'(num), '!'(num)], (_ >= _), []).
'$builtin_type_info'('=<', relation, ['!'(num), '!'(num)], (_ =< _), []).
'$builtin_type_info'('@>', relation, ['!'(term), '!'(term)], (_ @> _), []).
'$builtin_type_info'('@<', relation, ['!'(term), '!'(term)], (_ @< _), []).
'$builtin_type_info'('@>=', relation, ['!'(term), '!'(term)], (_ @>= _), []).
'$builtin_type_info'('@=<', relation, ['!'(term), '!'(term)], (_ @=< _), []).
'$builtin_type_info'('in', relation, ['?'(T), '!'('$list_type'(T))],
                     (_ in _), [T='T']).
'$builtin_type_info'('in', relation, ['+?'(T), '!'('$list_type'('+?'(T)))],
                     (_ in _), [T='T']).
'$builtin_type_info'('in', relation, ['?'(T), '!'('$set_type'(T))],
                     (_ in _), [T='T']).
'$builtin_type_info'('in', relation, ['?'(string), '!'(string)], (_ in _), []).
'$builtin_type_info'(true, relation, [], true, []).
'$builtin_type_info'(false, relation, [], false, []).
'$builtin_type_info'(fail, action, [], fail, []).
'$builtin_type_info'('$time_', relation, ['?'(num)], '$time_'(_), []).

%'$builtin_type_info'(template, relation, ['+?'(term)], template(_), []).

%'$builtin_type_info'('ground_inputs', relation, ['+?'(relcall)],
%		     ground_inputs(_), []).
'$builtin_type_info'('call', relation, ['+?'(relcall)], call(_), []).
'$builtin_type_info'('not', relation, ['??'(relcall)], not(_), []).
'$builtin_type_info'('ground', relation, ['??'(term)], ground(_), []).
'$builtin_type_info'('template', relation, ['??'(term)], template(_), []).
'$builtin_type_info'('ground_inputs', relation, ['??'(relcall)], ground_inputs(_), []).
'$builtin_type_info'('ground_inputs', relation, ['??'(actcall)], ground_inputs(_), []).
'$builtin_type_info'('type', relation, ['??'(term), '!'(typeE(_))],
		     type(_, _), []).
'$builtin_type_info'('typeC', relation, ['??'(term), '!'(typeE(_)),
					 '?'('$list_type'('+?'(term)))],
		     typeC(_, _, _), []).
'$builtin_type_info'('isa', relation, ['?'(term), '!'(typeE(_))], isa(_, _), []).
'$builtin_type_info'(append, relation,
                     [!('$list_type'(T)), !('$list_type'(T)),
                      ? '$list_type'(T)], append(_, _, _), [T = 'T']).
'$builtin_type_info'(append, relation,
                     [? '$list_type'(T), ? '$list_type'(T),
                      !('$list_type'(T))], append(_, _, _), [T = 'T']).
'$builtin_type_info'(append, relation,
                     [!('$list_type'(+?(T))), !('$list_type'(+?(T))),
                      ? '$list_type'(+?(T))], append(_, _, _), [T = 'T']).
'$builtin_type_info'(append, relation,
                     [? '$list_type'(+?(T)), ? '$list_type'(+?(T)),
                      !('$list_type'(+?(T)))], append(_, _, _), [T = 'T']).
'$builtin_type_info'(append, relation,
                     [+?('$list_type'(T)), +?('$list_type'(T)),
                      +?('$list_type'(T))], append(_, _, _), [T = 'T']).
'$builtin_type_info'(member, relation,
                     ['?'(T), '!'('$list_type'(T))],
                     member(_, _), [T = 'T']).
'$builtin_type_info'(member, relation,
                     ['+?'(T), '+?'('$list_type'(T))],
                     member(_, _), [T = 'T']).
'$builtin_type_info'(reverse, relation,
                     ['!'('$list_type'('+?'(T))), '?'('$list_type'('+?'(T)))],
                     reverse(_, _), [T = 'T']).
'$builtin_type_info'(string2term, relation,
                     ['!'(string), '+?'(term)],
                     string2term(_, _), []).
'$builtin_type_info'(sort, relation,
                     ['!'('$list_type'('+?'(T))), '?'('$list_type'('+?'(T)))],
                     sort(_, _), [T = 'T']).
'$builtin_type_info'(readT, relation, ['+?'(term)], readT(_), []).
'$builtin_type_info'(type_info, relation, ['?'(typeE(_)), '?'(type_kind_)],
                                           type_info(_, _), []).

'$builtin_type_info'(':=', action, ['!'('?'(int) <=), '!'(int)],
                     ':='(_,_), []).
%'$builtin_type_info'(':=', action, ['!'(atom), '!'(int)],
%                     ':='(_,_), []).
'$builtin_type_info'(':=', action, ['!'('?'(num) <=), '!'(num)],
                    ':='(_,_), []).
%'$builtin_type_info'(':=', action, ['!'(atom) , '!'(num)],
%                     ':='(_,_), []).
'$builtin_type_info'('+:=', action, ['!'('?'(int) <=), '!'(int)],
                     '+:='(_,_), []).
%'$builtin_type_info'('+:=', action, ['!'(atom), '!'(int)],
%                     '+:='(_,_), []).
'$builtin_type_info'('+:=', action, ['!'('?'(num) <=), '!'(num)],
                     '+:='(_,_), []).
%'$builtin_type_info'('+:=', action, ['!'(atom), '!'(num)],
%                     '+:='(_,_), []).
'$builtin_type_info'('-:=', action, ['!'('?'(int) <=), '!'(int)],
                     '-:='(_,_), []).
%'$builtin_type_info'('-:=', action, ['!'(atom) ,'!'(int)],
%                     '-:='(_,_), []).
'$builtin_type_info'('-:=', action, ['!'('?'(num) <=), '!'(num)],
                    '-:='(_,_), []).
%'$builtin_type_info'('-:=', action, ['!'(atom) , '!'(num)],
%                     '-:='(_,_), []).
'$builtin_type_info'('do', action, ['+?'(actcall)], do(_), []).
'$builtin_type_info'('remember', action, [relcall], remember(_), []).
'$builtin_type_info'('rememberA', action, [relcall], rememberA(_), []).
'$builtin_type_info'('remember_for', action, [relcall, num],
		     remember_for(_, _), []).
'$builtin_type_info'('rememberA_for', action, [relcall, num],
		     rememberA_for(_, _), []).
'$builtin_type_info'('forget', action, [relcall], forget(_), []).
'$builtin_type_info'('forget_after', action, [relcall, num],
		     forget_after(_, _), []).
'$builtin_type_info'('replace_by', action, [relcall, relcall], replace_by(_,_), []).
'$builtin_type_info'('fork_as', action, [actcall, '?'(atom)], fork_as(_, _), []).
'$builtin_type_info'(writeLine, action, ['!'('$list_type'('??'(term)))],
                     writeLine(_), []).
'$builtin_type_info'(writeL, action, ['!'('$list_type'('??'(term)))], writeL(_), []).
'$builtin_type_info'(to, action, ['??'(term), '!'(handle)], to(_, _), []).
'$builtin_type_info'(from, action, ['+?'(term), '?'(handle)], from(_, _), []).

'$builtin_type_info'(set_default_message_thread, action,['!'(atom)],set_default_message_thread(_), []).

'$builtin_type_info'(start_agent, action, [atom, handle, atom],
                     start_agent(_, _, _), []).
%'$builtin_type_info'(start_drive, action, [atom, handle],
 %                    start_drive(_, _), []).
'$builtin_type_info'(start_task, action, [atom, trcall], start_task(_, _), []).
'$builtin_type_info'(kill_task, action, [atom], kill_task(_), []).
'$builtin_type_info'(kill_agent, action, [], kill_agent, []).
'$builtin_type_info'(thread_sleep, action, ['!'(num)], thread_sleep(_), []).

/*
'$builtin_type_info'(log, action, [handle], log(_), []).
'$builtin_type_info'(unlog, action, [], unlog, []).
'$builtin_type_info'(teleor, action, [], teleor, []).
'$builtin_type_info'(bs, action, [], bs, []).
*/

'$builtin_type_info'(actions, action,
                     ['$list_type'('$union_type'([discrete, durative]))],
                     actions(_), []).

/*
'$builtin_type_info'(start_eval, action, [trcall], start_eval(_), []).
'$builtin_type_info'(run, action, [trcall], run(_), []).
'$builtin_type_info'(new, action, [trcall, atom], new(_,_), []).
'$builtin_type_info'(do_task, action, trcall, atom], do_task(_,_), []).
'$builtin_type_info'(start, action, [], start, []).
*/
'$builtin_type_info'(task_, relation, ['?'(atom), '?'(trcall)], task_(_,_), []).
'$builtin_type_info'(time_, relation, ['?'(num)], time_(_), []).
'$builtin_type_info'(running_, relation, [atom], running_(_), []).
'$builtin_type_info'(waiting_, relation, [atom], waiting_(_), []).
'$builtin_type_info'(resources_, relation, [atom, '$list_type'(term)],
                     resources_(_, _), []).

'$builtin_type_info'(current_thread, relation, ['?'(atom)],
                     current_thread(_), []).  

'$builtin_type_info'(get_active_resources, relation, ['?'(term)],
		     get_active_resources(_), []).
'$builtin_type_info'(get_waiting_resources, relation, ['?'(term)],
		     get_waiting_resources(_), []).

'$builtin_type_info'(hand_shake_, defined_type, hand_shake_,
                     '$enum_type'([initialise_, finalise_]), []).
'$builtin_type_info'(control_action_, defined_type, control_action_,
                     '$constr_enum_type'([start_(durative), stop_(durative),
                                    mod_(durative), exec_(discrete)]), []).
'$builtin_type_info'(control_message_, defined_type, control_message_,
		     '$type_macro'(controls_('$list_type'(control_action_))),
		     []).
'$builtin_type_info'(robot_message_, defined_type, robot_message_,
                     '$union_type'([hand_shake_, control_message_]), []).


'$builtin_type_info'(type_kind_, defined_type, type_kind_,
                     '$constr_enum_type'([enumT_('$list_type'(atomic)),
                                          constrT_('$list_type'(term)),
                                          unionT_('$list_type'(term)),
                                          tupleT_('$list_type'(term)),
                                          rangeT_(int, int)]), []).
                                          
/*
'$builtin_type_info'(thread_in_process, defined_type,
                     thread_in_process, '$type_macro'(':'(atom, atom)), []).
'$builtin_type_info'(pedro_handle, defined_type,
                     pedro_handle, '$type_macro'('@'(thread_id, atom)), []).
'$builtin_type_info'(thread_id, defined_type,
                     thread_id, '$union_type'([atom, thread_in_process]), []).
'$builtin_type_info'(handle, defined_type,
                     handle, '$union_type'([thread_id,  pedro_handle]), []).
*/
/*
'$builtin_type_info'(thread_in_process, defined_type,
                     thread_in_process, '$type_macro'(':'(atom, atom)), []).
'$builtin_type_info'(process_handle, defined_type,
                     pedro_handle, '$type_macro'('@'(atom, atom)), []).
'$builtin_type_info'(pedro_handle, defined_type,
                     pedro_handle, '$type_macro'('@'(thread_in_process, atom)),
                     []).
'$builtin_type_info'(handle, defined_type,
                     handle, '$union_type'([atom, thread_in_process,
                                            agent_handle,pedro_handle]), []).
*/
'$builtin_type_info'(thread_in_process, defined_type,
                     thread_in_process, '$type_macro'(':'(atom, atom)), []).
'$builtin_type_info'(agent_handle, defined_type,
                     agent_handle, '$type_macro'('@'(atom, atom)), []).
'$builtin_type_info'(pedro_handle, defined_type,
                     pedro_handle, '$type_macro'('@'(thread_in_process, atom)),
                     []).
'$builtin_type_info'(handle, defined_type,
                     handle, '$union_type'([atom, thread_in_process,
                                            agent_handle,pedro_handle]), []).


'$builtin_type_info'(dynamic, defined_type,
                     dynamic, '$union_type'([belief, percept]), []).
'$builtin_type_info'(bottom, defined_type, bottom, '$enum_type'([bottom_]), []).

'$builtin_type_info'(write_type_nl__, defined_type, write_type_nl__,
                     '$enum_type'([nl_]), []).
'$builtin_type_info'(write_type_other__, defined_type, write_type_other__,
                     '$constr_enum_type'([sp_(int), q_(string), uq_(atom),
                                          wr_(term)]), []).

'$builtin_type_info'(write_type__, defined_type, write_type__,
                     '$union_type'([write_type_nl__, write_type_other__]), []).

                    

'$type_info'(A, B, C, D, E) :-
    '$builtin_type_info'(A, B, C, D, E).
'$type_info'(A, B, C, D, E) :-
    '$user_type_info'(A, B, C, D, E).
                          
'$defined_type'(A, B) :-
    '$type_info'(_, defined_type, A, B, _).
'$user_defined_type'(A, B) :-
    '$user_type_info'(_, defined_type, A, B, _).

'$dynamic_builtin_type_info'(A, B, C, D, E) :-
    '$builtin_type_info'(A, B, C, D, E),
    '$dynamic_builtin'(A).

'$belief_type_info'(A,C,D) :-
    '$type_info'(A, _, C, D, _),
    '$belief'(D).
'$percept_type_info'(A,C,D) :-
    '$type_info'(A, _, C, D, _),
    '$percept'(D).

'$dynamic_type_info'(A,C,D) :-
    '$belief_type_info'(A,C,D).
'$dynamic_type_info'(A,C,D) :-
    '$percept_type_info'(A,C,D).

'$relation_type_info'(A, C, D) :-
    '$type_info'(A, relation, C, D, _),
    \+'$belief'(D), \+'$percept'(D).
'$action_type_info'(A, C, D) :-
    '$type_info'(A, action, C, D, _).
   
'$real_kind'(Name, Kind) :-
    '$user_type_info'(Name, Kind0, _, _, _), !,
    (
      '$belief'(Name)
    ->
      Kind = belief
    ;
      Kind = Kind0
    ).
'$real_kind'(Name, Kind) :-
    '$type_info'(Name, Kind0, _, _, _),
    (
      Kind0 = relation
    ->
      Kind = 'system relation'
    ;
      Kind0 = function
    ->
      Kind = 'system function'
    ;
      Kind0 = action
    ->
      Kind = 'system action'
    ).

check_assert(Goal) :-
    call(Goal), !.
check_assert(Goal) :-
    errornl(failed_check_assert___________________(Goal)).

forall(_,C1,C2) :- forall(C1,C2).


sub_string(String,Before,Sub,After) :- 
    string(String), string(Sub), 
    string_length(String,StringN), string_length(Sub,SubN),
    SubN =< StringN,
    !,
    sub_string(String, StartSubN, SubN, RemainingN, Sub),
%    StartSubLess1 is StartSubN -1, 
    sub_string(String,0,StartSubN,_,Before),
    (RemainingN =0 -> After="" 
       ;
       AfterBegins is StartSubN+SubN,
       sub_string(String,AfterBegins,_,0,After)). 
sub_string(String,Before,Sub,After) :- 
    string(String), string(Before), string(After),
    !,
    sub_string(String,0,BeforeN,RemN,Before),
    sub_string(String,_,AfterN,_,After),
    ( RemN > AfterN -> sub_string(String, BeforeN, _, AfterN, Sub)
       ;
       Sub="").



?-op(500,fx,[show, type]).
types :-
    show_durative, fail.
types :-
    show_discrete, fail.
types :-
    '$user_type_info'(_, defined_type, T, DT, Vars),
    (
      DT = '$type_macro'(DT1)
    ->
      true
    ;
      DT1 = DT
    ),
    Defn = '::='(T,DT1),
    '$vars2names'(Defn, Vars),
    writeTerm(Defn), nl, fail.
types :-
    findall((F:K), ('$user_type_info'(F, K, _, _, _),
                       K \= defined_type,
                       \+'$should_suppress_show_type'(F)), Fs),
    sort(Fs, SFs),
    member((A:Kind), SFs),
    display_type(Kind, stdout, A), nl,fail.
types :- nl.

stypes :-
    '$builtin_type_info'(_, defined_type, T, DT, Vars),
    \+'$supress_defined_type'(T) ,
    (
      DT = '$type_macro'(DT1)
    ->
      true
    ;
      DT1 = DT
    ),
    Defn = '::='(T,DT1),
    '$vars2names'(Defn, Vars),
    writeTerm(Defn), 
     '$display_type_comment'(stdout, T), 
     nl,
     fail.
stypes :-
    findall((F:K), ('$builtin_type_info'(F, K, _, _, _),
                       K \= defined_type,
                       \+'$supress_builtin_type'(F)), Fs),
    sort(Fs, SFs),
    member((A:Kind), SFs),
    display_type(Kind, stdout, A), nl,fail.
stypes :- nl.

add_arrow(relation, B, <=(B)).
add_arrow(action, B, '~>>'(B)).
add_arrow(tr_prog, B, '~>'(B)).

types_durative(PP) :-
    '$user_type_info'(P, durative, Types, _, _),
    (
      (P==PP; once(sub_atom(P,1,_,PP)))
    -> 
     D =.. [P|Types],
     writeTerm(durative(D)),
     nl,
     fail
     ;
     fail
    ). 
types_discrete(PP) :-
    '$user_type_info'(P, discrete, Types, _, _),
    (
      (P==PP; once(sub_atom(P,1,_,PP)))
    -> 
      D =.. [P|Types],
     writeTerm(discrete(D)),
      nl,
      fail
     ;
      fail
    ). 

types(PList) :-
    list(PList), !,
    forall(member(P, PList), types(P)).
types(PP) :-
    types_durative(PP).
types(PP) :-
    types_discrete(PP).

types(PP) :-
    findall(P, ('$user_type_info'(P, _, _, _, _),
                      (P==PP; once(sub_atom(P,1,_,PP)))), AllP),
    sort(AllP, SAllP),
    member(Nm, SAllP),
    display_type(stdout, Nm),
    nl,
    fail.
types(_) :- nl.

stypes(PList) :-
    list(PList), !,
    forall(member(P, PList), stypes(P)).
stypes(PP) :-
    findall(P, ('$builtin_type_info'(P, _, _, _, _),
                      (P==PP; once(sub_atom(P,1,_,PP)))), AllP),
    sort(AllP, SAllP),
    member(Nm, SAllP),
    display_type(stdout, Nm),
    nl,
    fail.
stypes(_).


type_exact(R) :-
    '$get_declared_type'(R, F, T, Vars),
    '$vars2names'(T, Vars),
    writeTerm((F : T)), nl, fail.
type_exact(_).



'$get_declared_type'(R, A, Type, Vars) :-
    '$get_ultimate_functor'(R, A),
    '$user_type_info'(A, _Kind, Type, _, Vars).
    %'$get_declared_type_aux'(Kind, R, A, Type).

/*
'$get_declared_type_aux'(relation, R, A, Type) :-
    !,
    (
      '$saved_input_with_vars'((A:B), Vars)
    ->
      (
        B = '<='(_)
      ->
        Type = B
      ;
        Type = '<='(B)
      )
    ; %% dynamic
      Type = '<='(T), Vars = []
    ).
'$get_declared_type_aux'(action, R, A, Type, Vars) :-
    !,
    '$saved_input_with_vars'((A:B), Vars),
    (
      B = '~>>'(_)
    ->
      Type = B
    ;
      Type = '~>>'(B)
    ).
'$get_declared_type_aux'(tr_prog, R, A, Type, Vars) :-
    !,
    '$saved_input_with_vars'((A:B), Vars),
    (
      B = '~>'(_)
    ->
      Type = B
    ;
      Type = '~>'(B)
    ).
'$get_declared_type_aux'(function, R, A, Type, Vars) :-
    '$saved_input_with_vars'((A:Type), Vars).
*/
display_type(Stream, P) :-
    once('$type_info'(P, K, _, _, _)),
    display_type(K, Stream, P).

display_type(relation, Stream, P) :-
    '$percept_type_info'(P, Types, _), !,
    writeL(Stream, ["percept ", P:'$tuple_type'(Types)]),
    '$display_type_comment'(Stream, P).
display_type(relation, Stream, P) :-
    '$belief_type_info'(P, Types, _), !,
    writeL(Stream, ["belief ", P:'$tuple_type'(Types)]),
    '$display_type_comment'(Stream, P).
    
display_type(relation, Stream, P) :-
    findall('<='('$tuple_type'(T1)),
            ('$type_info'(P, _, T1, _, DV),'$vars2names'(T1, DV)), AllT),
    (
      AllT = [T]
    ->
      true
    ;
      T = alt_types(AllT)
    ),
    writeL(Stream, [(P : T)]),
    '$display_type_comment'(Stream, P).
display_type(action, Stream, P) :-
    findall('~>>'('$tuple_type'(T1)),
            ('$type_info'(P, _, T1, _, DV),'$vars2names'(T1, DV)), AllT),
    (
      AllT = [T]
    ->
      true
    ;
      T = alt_types(AllT)
    ),
    writeL(Stream, [(P : T)]),
    '$display_type_comment'(Stream, P).
display_type(function, Stream, P) :-
    findall(T1,
            ('$type_info'(P, _, T1, _, DV),'$vars2names'(T1, DV)), AllT),
    (
      AllT = [T]
    ->
      true
    ;
      T = alt_types(AllT)
    ),
    writeL(Stream, [(P : T)]),
    '$display_type_comment'(Stream, P).
display_type(tr_prog, Stream, P) :-  
    '$type_info'(P, tr_prog, T, _, DVars),
    '$vars2names'(T, DVars),
    writeL(Stream, [(P : '~>'('$tuple_type'(T)))]),
    '$display_type_comment'(Stream, P).

'$display_type_comment'(Stream, P) :-
    '$builtin_type_descr'(P, Comment), !,
    writeL(Stream, [nl_,sp_(2),uq_('  % '), Comment]).
'$display_type_comment'(_, _).

show_relation_clause(P) :-
    findall(C, get_a_relation_clause(P, C), Cs),
    (
      Cs  = []
    ->
      !
    ;
      display_type(stdout, P),
      writeL([nl_]),
      member(c(Rule, Vars), Cs),
      '$vars2names'(Rule, Vars),
      show_clause(Rule),
      fail
    ).
show_relation_clause(_P) :-
    writeL([nl_]).
    
show_percept_clause(P) :-
    findall(C, get_a_percept_clause(P, C), Cs),
    (
      Cs = []
    ->
      !
    ;
      '$percept_type_info'(P, Types, _),
      writeL(["percept ", P:'$tuple_type'(Types), nl_]),
      member(c(Rule, Vars), Cs),
      '$vars2names'(Rule, Vars),
      show_clause(Rule),
      fail
    ).
show_percept_clause(_P) :-
    writeL([nl_]).

show_belief_clause(P) :-
    findall(C, get_a_belief_clause(P, C), Cs),
    (
      Cs = []
    ->
      !
    ;
      '$belief_type_info'(P, Types, _),
      writeL(["belief ", P:'$tuple_type'(Types), nl_]),
      member(c(Rule, Vars), Cs),
      '$vars2names'(Rule, Vars),
      show_clause(Rule),
      fail
    ).
show_belief_clause(_P) :-
    writeL([nl_]).

show_action_clause(P) :-
    findall(C, get_a_action_clause(P, C), Cs),
    (
      Cs = []
    ->
      !
    ;
      display_type(stdout, P),
      writeL([nl_]),
      member(c(Rule, Vars), Cs),
      '$vars2names'(Rule, Vars),
      show_clause(Rule),
      fail
    ).
show_action_clause(_P) :-
    writeL([nl_]).

show_function_clause(P) :-
    findall(C, get_a_function_clause(P, C), Cs),
    (
      Cs = []
    ->
      !
    ;
      display_type(stdout, P),
      writeL([nl_]),
      member(c(Rule, Vars), Cs),
      '$vars2names'(Rule, Vars),
      show_clause(Rule),
      fail
    ).
show_function_clause(_P) :-
    writeL([nl_]).

show_tr_prog(P) :-
    '$type_info'(P, tr_prog, _T, H, _DVars),!,
    TR = '$tr_prog'(H, _R),
    '$saved_input_with_vars'(TR, Vars),
    display_type(stdout, P),
    writeL([nl_]),
    '$vars2names'(TR, Vars),
    writeTerm(TR),
    writeL([nl_]).

show_durative :-
    findall(durative(P, Types),
            '$user_type_info'(P, durative, Types, _, _), DS),
    (
      DS = []
    ->
      !
    ;
      sort(DS, SDS),
      member(durative(P, Types), SDS),
      writeL(["durative ", P:'$tuple_type'(Types), nl_]),
      fail
    ).
show_durative :-
    writeL([nl_]).

show_discrete :-
    findall(discrete(P, Types),
            '$user_type_info'(P, discrete, Types, _, _), DS),
    (
      DS = []
    ->
      !
    ;
      sort(DS, SDS),
      member(discrete(P, Types), SDS),
      writeL(["discrete ", P:'$tuple_type'(Types), nl_]),
      fail
    ).
show_discrete :-
    writeL([nl_]).


show :-
    show_durative,fail.
show :-
    show_discrete,fail.

show :-
    findall(PX, '$relation_type_info'(PX, _, _), PS),
    sort(PS, PSS),
    member(P, PSS),
    show_relation_clause(P),
    fail.
show :-
    findall(PX, '$belief_type_info'(PX, _, _), PS),
    sort(PS, PSS),
    member(P, PSS),
    show_belief_clause(P),
    fail.
show :-
    findall(PX, '$percept_type_info'(PX, _, _), PS),
    sort(PS, PSS),
    member(P, PSS),
    show_percept_clause(P),
    fail.

show :-
    findall(PX, '$user_type_info'(PX, action, _, _, _), PS),
    sort(PS, PSS),
    member(P, PSS),
    show_action_clause(P),
    fail.
show :-
    findall(PX,
            ('$user_type_info'(PX, function, _, T, _), T \= '$function'), PS),
    sort(PS, PSS),
    member(P, PSS),
    show_relation_clause(P),
    fail.
show :-
    findall(PX, '$user_type_info'(PX, function, _, '$function', _), PS),
    sort(PS, PSS),
    member(P, PSS),
    show_function_clause(P),
    fail.
show :-
    findall(PX, '$user_type_info'(PX, tr_prog, _, _, _), PS),
    sort(PS, PSS),
    member(P, PSS),
    show_tr_prog(P),
    fail.

show.
    
get_a_percept_clause(P, c(H,[])) :-
    '$percept_type_info'(P, _, H),
    call(H).
/*
    '$saved_input_with_vars'(Rule, Vars),
    (
      Rule = (H :: _ <= _)
    ->
     true
    ;
      Rule = (H :: _ )
    ->
     true
    ;
      Rule = (H <= _)
    ->
     true
    ;
      Rule = H
    ).
  */
get_a_belief_clause(P, c(H,[])) :-
    '$belief_type_info'(P, _, H),
    call(H).
get_a_relation_clause(P, c(Rule,Vars)) :-
    '$relation_type_info'(P, _, H), !,
    '$saved_input_with_vars'(Rule, Vars),
    (
      Rule = (H :: _ <= _)
    ->
     true
    ;
      Rule = (H :: _ )
    ->
     true
    ;
      Rule = (H <= _)
    ->
     true
    ;
      Rule = H
    ).

get_a_relation_clause(P, c(Rule,Vars)) :-
    '$type_info'(P, function, _, T, _), T \= '$function', !,
    '$saved_input_with_vars'(Rule, Vars),
    (
      Rule = (H :: _ <= _)
    ;
      Rule = (H :: _ )
    ;
      Rule = (H <= _)
    ;
      Rule = H
    ),
    '$get_ultimate_functor'(H, P).

get_a_action_clause(P, c(Rule,Vars)) :-
    '$type_info'(P, action, _, H, _),!,
    '$saved_input_with_vars'(Rule, Vars),
    (
      Rule = (H :: _ ~>> _)
    ;
    %  Rule = '~>>'((H :: _ ))
    %;
      Rule = (H ~>> _)
    ;
      Rule = '~>>'(H)
    ).

get_a_function_clause(P, c(Rule,Vars)) :-
    '$type_info'(P, function, _, '$function', _),
    '$saved_input_with_vars'(Rule, Vars),
    (
      Rule = (H :: _ -> _)
    ;
      Rule = (H -> _)
    ),
    '$get_ultimate_functor'(H, P).

?-dynamic('$watched'/1).

/*
maybeExtendHead(H,P,K,EH) :-
    '$watched'(P/K), % a watch on P/K has been set
    !,
    atom_concat2(P,'_watched',NP),
    functor(EH,NP,K).
maybeExtendHead(H,_,_,H).
*/

show_exact(P) :-
    once('$relation_type_info'(P, _, _)),
    show_relation_clause(P),
    fail.
show_exact(P) :-
    once('$percept_type_info'(P, _, _)),
    show_percept_clause(P),
    fail.
show_exact(P) :-
    once('$belief_type_info'(P, _, _)),
    show_belief_clause(P),
    fail.
show_exact(P) :-
    once('$user_type_info'(P, action, _, _, _)),
    show_action_clause(P),
    fail.
show_exact(P) :-
    once('$user_type_info'(P, function, _, T, _)), T \= '$function',
    show_relation_clause(P),
    fail.

show_exact(P) :-
    once('$user_type_info'(P, function, _, '$function', _)),
    show_function_clause(P),
    fail.

show_exact(_P) :- !.

show(PList) :-
    list(PList), !,
    forall(member(P, PList), show(P)).
show(PP) :-
    %nl,
    types_durative(PP).
show(PP) :-
    %nl,
    types_discrete(PP).

show(PP) :-
    findall(P, ('$relation_type_info'(P, _, _),
                   ( P==PP; once(sub_atom(P,1,_,PP) ))), Ps),
    sort(Ps, SPs),
    member(P, SPs),
    show_exact(P),
    %nl,
    fail.
show(PP) :-
    findall(P, ('$percept_type_info'(P, _, _),
                   ( P==PP; once(sub_atom(P,1,_,PP) ))), Ps),
    sort(Ps, SPs),
    member(P, SPs),
    show_exact(P),
    %nl,
    fail.
    
show(PP) :-
    findall(P, ('$belief_type_info'(P, _, _),
                   ( P==PP; once(sub_atom(P,1,_,PP) ))), Ps),
    sort(Ps, SPs),
    member(P, SPs),
    show_exact(P),
    %nl,
    fail.
     /*
    '$belief_type_info'(P, Types, G),
    (
      (P==PP; once(sub_atom(P,1,_,PP)))
    ->
      findall(G, call(G), Gs),
      T =.. [P|Types],
      writeL([nl_, belief(T), nl_]),
      forall(member(G1, Gs), writeL([G1, nl_])),
      fail
     ;
      nl,fail
    ).
      */
show(PP) :-
    findall(P, ('$user_type_info'(P, action, _, _, _),
                   ( P==PP; once(sub_atom(P,1,_,PP) ))), Ps),
    sort(Ps, SPs),
    member(P, SPs),
    show_exact(P),
    nl,
    fail.
show(PP) :-
    findall(P, ('$user_type_info'(P, function, _, _, _),
                   ( P==PP; once(sub_atom(P,1,_,PP) ))), Ps),
    sort(Ps, SPs),
    member(P, SPs),
    show_exact(P),
    nl,
    fail.
show(PP) :-
    '$user_type_info'(P, tr_prog, _, _, _),
    (
      (P==PP; once(sub_atom(P,1,_,PP)))
    ->
      show_tr_prog(P),
      nl,
      fail
    ;
      fail
    ). 
show(_).

show_clause(C) :-
    show_clause(C, stdout).

show_clause((Head :: Test <= Body), Stream) :-
    !,
    writeTerm(Stream, Head),
    writeL(Stream, [' ::', nl_]),
    show_body(Test,3, Stream),
    writeL(Stream, [' <=', nl_]),
    show_body(Body,6, Stream),
    nl(Stream).
    
show_clause((Head <= Body), Stream) :-
    !,
    writeTerm(Stream, Head),
    writeL(Stream, [" <=", nl_]),
    show_body(Body,3, Stream),
    nl(Stream).

show_clause((Head :: Test ~>> Body), Stream) :-
    !,
    writeTerm(Stream, Head),
    writeL(Stream, [" ::", nl_]),
    show_body(Test,3, Stream),
    writeL(Stream, [" ~>>", nl_]),
    show_body(Body,6, Stream),
    nl(Stream).
/*
  show_clause('~>>'((Head :: Test)), Stream) :-
     !,
    writeTerm(Stream, Head),
    writeL(Stream, [' ::', nl_]),
    show_body(Test,3, Stream),
    writeL(Stream, [' ~>>', nl_]),
    nl(Stream).
*/
show_clause((Head ~>> Body), Stream) :-
    !,
    writeTerm(Stream, Head),
    writeL(Stream, [" ~>>", nl_]),
    show_body(Body,3, Stream),
    nl(Stream).
show_clause('~>>'(Head), Stream) :-
    !,
    writeTerm(Stream, Head),
    writeL([" ~>>", nl_]),
    nl(Stream).
show_clause((Head :: Test), Stream) :-
     !,
    writeTerm(Stream, Head),
    writeL(Stream, [" ::", nl_]),
    show_body(Test,3, Stream),
    nl(Stream).

show_clause((Head -> Body), Stream) :-
    !,
    writeL(Stream, [(Head -> Body), nl_]).

show_clause(Head, Stream) :-
    writeTerm(Stream, Head), nl.

show_clause("->", SPHead,SPBody, Stream) :- !,
    writeL(Stream, [(SPHead -> SPBody), nl_]).

'$is_clause_defn'((_A :: _B <= _C)).
'$is_clause_defn'((_A :: _B ~>> _C)).
'$is_clause_defn'((_A :: _B)).
'$is_clause_defn'((_A <= _C)).
'$is_clause_defn'((_A  ~>> _C)).

show_body( Cond,Indent, Stream) :-
	   Cond\= (_ & _),
	   Cond\= (_ ; _),
            Cond\=(_,_),
	   !,
           tab(Stream, Indent),
           show_cond(Cond, Indent, Stream).
show_body(And(Cond,Conds), Indent, Stream):-
	tab(Stream, Indent),
        show_cond(Cond, Indent, Stream),
	(And='&' -> write(Stream, ' &\n')
	 ;
	 And=';' -> write(Stream, ' ;\n')
	;
         write(Stream, ' ,\n')
	 ),
         show_body(Conds, Indent, Stream).

/*
show_cond( (@ Vars :: C1 => C2), Indent) :-
       !,
       I1 is Indent+5,
       I2 is Indent+13,
       writeL([ '(@ ', Vars, ' ::\n',tab(I1), C1, ' =>\n',tab(I2), C2,')']).     
show_cond( (forall Vars where C1 then C2) ) :-
       !,
       writeL([ '(forall ', Vars, ' where\n',tab(8), C1, ' then\n',tab(15), C2,')']).     
*/
show_cond(Cond, _, Stream) :-
	writeTerm(Stream, Cond).

print__(Term) :-
    ip_lookup(colons_used, false), !,
    print__aux(Term).
print__(Term) :-
    global_state_lookup('$total_solns2print', M),
    '$print_alt_expression_soln'(M, Term),
    print__aux(Term),
    '$qulog_interpreter_cont_section'([]).

print__aux(Term) :-
    %ip_lookup(query_type___, expression(EType)),
    (
      type(Term, Type, Bindings)
    ->
      (
        Bindings = []
      ->
        get_all_types(Term, AllType),
        writeTerm(Term), writeL([" : "]),
        '$display_type_info'(AllType),
        writeL([nl_])
      ;
        writeTerm(Term),writeL([" : "]),
       map('$strip_out_types', Bindings, BTypes),
       collect_vars(BTypes, TypeVars),
       reverse(TypeVars, RevTypeVars),
       '$name_type_vars'([_|RevTypeVars]),
        '$display_type_info'(Type),
        %%writeL([" : ", wr_(Type)]),
        writeL([" with ", Bindings, nl_])
      )
    ;
       writeTerm(Term),
      writeL([" : Cannot deduce expression type", nl_])
    ).

'$display_type_info'(alt_types([T|Types])) :-
    !,
    '$display_type_info'(T),
    (
      member(T1, Types),
      writeL([" | "]),
      '$display_type_info'(T1),
      fail
    ;
      true
    ).
'$display_type_info'(T) :-
    collect_vars(T, Vars),
    reverse(Vars, RVars),
    '$name_type_vars'([_|RVars]),
    writeL([T]), fail.
'$display_type_info'(_).



get_all_types(Term, Type) :-
    findall(T, has_type2(Term, T, [], _OutVMT), AltTypes),
    merge_types__(AltTypes, Type).

merge_types__(AltTypes, Type) :-
    '$collect_min_types'(AltTypes, [], SimpAltTypes), 
    remove_identical_patterns__(SimpAltTypes, SimpSimpAltTypes),
    (
      SimpSimpAltTypes = [T1]
    ->
      Type = T1
    ;
      Type = alt_types(SimpSimpAltTypes)
    ).

'$collect_min_types'([], _, []).
'$collect_min_types'([T|Ts], Seen, Simp) :-
    member(T1, Ts), type_le(T1, T), !,
    '$collect_min_types'(Ts, Seen, Simp).
'$collect_min_types'([T|Ts], Seen, Simp) :-
    member(T1, Seen), type_le(T1, T), !,
    '$collect_min_types'(Ts, Seen, Simp).
'$collect_min_types'([T|Ts], Seen, Simp) :-
    '$collect_min_types'(Ts, [T|Seen], Simp1),
    Simp = [T|Simp1].


remove_identical_patterns__([], []).
remove_identical_patterns__([X|T], ST) :-
    member(Y, T),
    identical_patterns(X, Y), !,
    remove_identical_patterns__(T, ST).
remove_identical_patterns__([X|T], [X|ST]) :-
    remove_identical_patterns__(T, ST).

identical_patterns(X, Y) :-
    freeze_term(X),
    X \= Y, !,
    fail.
identical_patterns(X, Y) :-
    freeze_term(Y),
    X \= Y, !,
    fail.
identical_patterns(_, _).

zip__([[]|_], []) :- !.
zip__(Xs, [Heads|Result]) :-
    split__(Xs, Heads, Tails),
    zip__(Tails, Result).

split__([], [], []) :- !.
split__([[H|T]|Tail], [H|Hs], [T|Ts]) :-
    split__(Tail, Hs, Ts).

    

'$higher_order_term'(T) :-
    compound(T),
    functor(T, F, _N),
    compound(F).

'$higher_order_type'(Type) :-
    nonvar(Type),
    (
      Type = (_ -> _)
    ->
      true
    ;
      '$defined_type'(Type, '$type_macro'(DType)),
      '$higher_order_type'(DType)
    ).



'$get_ultimate_functor'(Term, F) :-
    \+compound(Term), !, F = Term.
'$get_ultimate_functor'(Term, F) :-
    functor(Term, F1, _),
    '$get_ultimate_functor'(F1, F).


'$generate_apply_name'(F, Name) :-
    '$get_ultimate_functor'(F, UF),
    atom(UF),
    atom_concat(UF, '$apply', Name).
    
'$atom_functor'(Term) :-
    atom(Term), !.
'$atom_functor'(Term) :-
    compound(Term),
    functor(Term, F, _),
    atom(F).

'$vars2names'(Term, Vars) :-
    '$do_unifs'(Vars),
    collect_vars(Term, UVars),
    '$unify_underscore'(UVars).

'$do_unifs'([]).
'$do_unifs'([(A=B)|U]) :-
    A = '$$var$$'(B), !,
    '$do_unifs'(U).
'$do_unifs'([_|U]) :-
    '$do_unifs'(U).

'$unify_underscore'([]).
'$unify_underscore'(['$$var$$'('_')|UV]) :-
    '$unify_underscore'(UV).



'$get_function_type_info'(A, Args, Types, ResultType) :-
    '$get_ultimate_functor'(A, F),
    '$type_info'(F, function, _, _, _), !,
    '$type_info'(F, function, Type, _, _),
    '$get_function_type_info_aux'(A, Type, Args, Types, ResultType).
'$get_function_type_info'(A, Args, Types, ResultType) :-
    '$had_function_clauses'(A), !, 
    '$gen_type_term_pattern'(A, F, term, Type),
    '$get_full_goal_term'(F, Type, GT),
    assert('$user_type_info'(F, function, Type, GT, [])),
    assert('$saved_input_with_vars'((F : Type), [])),
    writeL(stderr, [nl_, "Warning: undeclared function ",  F,
		    nl_, "Declaring with type ", Type, nl_, nl_]),
    '$get_function_type_info'(A, Args, Types, ResultType).

'$gen_type_term_pattern'(A, F, InType, Type) :-
    compound(A),!,
    A =.. [F1|Args],
    findall(term, (member(X, Args), X \== '$none_'), Terms),
    (
     Terms = [Types]
    ->
     true
    ;
     Types = '$tuple_type'(Terms)
    ),
    '$gen_type_term_pattern'(F1, F, (Types -> InType), Type).
'$gen_type_term_pattern'(A, A, Type, Type).

'$had_function_clauses'(A) :-
    nonvar(A),'$get_ultimate_functor'(A, F),
    '$saved_input_with_vars'(B, _),
    (
     B = (Head -> _), '$get_ultimate_functor'(Head, F)
    ;
     B = (Head :: _ -> _), '$get_ultimate_functor'(Head, F)
    ), !.

'$get_function_type_info_aux'(Term, ResultType, [], [], ResultType) :-
    \+compound(Term),
    !.
%'$get_function_type_info_aux'(Term, ResultType, [], [], RTypes) :-
%    compound(ResultType),
%     ResultType =.. [F|RTypes], F == '<=', errornl(ResultType),!.
     
'$get_function_type_info_aux'(Term, ResultType, OutArgs,
                              OutTypes, FinalResultType) :-
    Term =.. [F|A1],
    %%'$list2tuple'(A, AT),
    (
      A1 = [X], X == '$none_'
    ->
      A = []
    ;
      A = A1
    ),
    (
      A = [Z]
    ->
      Arg = Z
    ;
      Arg = '$tuple'(A)
    ),
    (
      ResultType = (T1 -> T2)
    ->
      '$get_function_type_info_aux'(F, T2, Args, Types,  FinalResultType)
    ;
      '$defined_type'(ResultType, '$type_macro'((T1 -> T2)))
    ->
      '$get_function_type_info_aux'(F, T2, Args, Types,  FinalResultType)
    ;
      ResultType = '<='(T1),
      FinalResultType = relation,
      Args = [],
      Types = []
    ),
    OutArgs = [Arg|Args],
    append(Types, [T1], OutTypes).

'$get_full_goal_term'(_FName, Type, GT) :-
    \+compound(Type), !, GT = '$function'.
'$get_full_goal_term'(FName, Type, GT) :-
    functor(Type, F, 2), F == '->', !,
    Type = (T1 -> T2),
    '$tuple_type_to_list'(T1, T1L),
    length(T1L, N),
    length(Args, N),
    NextF =.. [FName|Args],
    '$get_full_goal_term'(NextF, T2, GT).
'$get_full_goal_term'(FName, Type, GT) :-
    functor(Type, F, 1), F == '<=', !,
    Type = '<='(T1),
    '$tuple_type_to_list'(T1, T1L),
    length(T1L, N),
    length(Args, N),
    GT =.. [FName|Args].
'$get_full_goal_term'(_FName, _Type, GT) :-
    GT = '$function'.

'$builtin_query'(X) :- '$special_builtin_query'(X).
'$builtin_query'('$exists'(_,_)).
'$builtin_query'('$forall'(_,_,_)).
'$builtin_query'('$at_forall'(_,_,_)).
'$builtin_query'('$forall_actions'(_,_,_)).
'$builtin_query'('$at_forall_actions'(_,_,_)).
'$builtin_query'(true).

'$special_builtin_query'(type(_, _)).
'$special_builtin_query'(typeC(_, _)).
'$special_builtin_query'(typeC(_, _, _)).
'$special_builtin_query'(typeG(_, _)).
'$special_builtin_query'(typeG(_, _, _)).
'$special_builtin_query'(isa(_, _)).
'$special_builtin_query'(remember(_)).
'$special_builtin_query'(remember_for(_,_)).
'$special_builtin_query'(rememberA(_)).
'$special_builtin_query'(rememberA_for(_,_)).
'$special_builtin_query'(forget(_)).
'$special_builtin_query'(forget_after(_,_)).
'$special_builtin_query'(replace_by(_,_)).
'$special_builtin_query'(':=+'(_, _)).
'$special_builtin_query'(':=-'(_, _)).

'$check_query'(Query, Vars) :-
    (
      '$builtin_query'(Query)
    ;
      '$type_info'(_, relation, _, Query, _)
    ;
     '$type_info'(_, action, _, Query, _)
    ;
      compound(Query), functor(Query, F, _), F == '&'
    ;
      compound(Query), functor(Query, F, _), F == ';'    
    ), !,
    '$check_goal_expressions'(Query, Query, Vars, any).
/*
'$check_query'(Query, Vars) :-
    '$get_ultimate_functor'(Query, F),
    '$type_info'(F, function, _, '<='(_)), !,
    errornl(checking____),
    '$check_goal_expressions'(Query, Query, Vars).
*/
'$check_query'(show, _) :- !.
'$check_query'(show(_), _) :- !.
    
'$check_query'(Query, Vars) :-
    '$check_expressions'(Query, Query, Vars).

'$translate_query'(Query, TQuery) :-
    ip_set('$tr_prog_vars', []),
    %freeze_term(Query),
     (
      '$type_info'(_, _, _, Query, _)
     ;
       Query = (_ & _)
     ;
       Query = (_ ; _)
     ;
      '$is_a_type_test'(Query, _, _)
     ;
      '$builtin_query'(Query)
    ), !,
    '$translate_goal'(Query, TQuery),
    freeze_term(TQuery).
%%,thaw_term(TQuery).

'$translate_query'('::'(X, Query), TQuery) :- !,
    ip_set('$tr_prog_vars', []),
    '$translate_body'((Query, print__(X)),  TQuery).
'$translate_query'(Query, TQuery) :-
    ip_set('$tr_prog_vars', []),
    '$translate_body'((Query '=?' X, print__(X)),  TQuery).
    

'$reset_time_fact' :-
    retract('__time__'(dummy,_)), !,
    gettimeofday(T),
    %%errornl(reset_time_fact),
    assert('__time__'(dummy, T)).
'$reset_time_fact' :-
     gettimeofday(T),
     assert('__time__'(dummy, T)).
    

'$goals2list'((B1 & B2), BL) :-
    !,
    '$goals2list'(B1, BL1),
    '$goals2list'(B2, BL2),
    append(BL1, BL2, BL).
'$goals2list'((B1 ; B2), BL) :-
    !,
    '$goals2list'(B1, BL1),
    '$goals2list'(B2, BL2),
    append(BL1, BL2, BL).
'$goals2list'(B, [B]).

remember(C):-
    clause(C,true), !.
remember(C) :-
    '$reset_time_fact',
    assert(C).

remember_for(Term, Secs) :-
    thread_atomic_goal((
                        remember(Term),
                        create_timer(forget(Term), Secs, true, _)
                      )).


rememberA(C):-
    clause(C,true), !.
rememberA(C) :-
    '$reset_time_fact',
    asserta(C).

rememberA_for(Term, Secs) :-
    thread_atomic_goal((
                        rememberA(Term),
                        create_timer(forget(Term), Secs, true, _)
                      )).


forget(C) :-
    retract(C), '$reset_time_fact', !.
forget(_).

forget_after(Term, Secs) :-
    thread_atomic_goal((
                        create_timer(forget(Term), Secs, true, _)
                      )).


%forgetall(C) :- retractall(C), '$reset_time_fact'.


'$quick_replace'(C1, C2) :-
    clause(C1, true), C1 = C2, !.
'$quick_replace'(C1, C2) :-
    forget(C1), remember(C2).



'$replace_by'(G) :-
    thread_atomic_goal(G).
'$replace1'(G) :-
    retract(G).
'$replace2'(G) :-
    assert(G).

replace(C1, C2) :-
    clause(C1, true), C1 = C2, !.
replace(C1, C2) :-
    thread_atomic_goal((retract(C1),assert(C2))),
    !.

'$add_input'(X, '!'(X)).

'$flatten_list'([], []).
'$flatten_list'([H|T], F) :-
    (
      nonvar(H),H = '$union_type'(AL)
    ->
      '$flatten_list'(AL, HF),
      append(HF, F1, F)
    ;
      F = [H|F1]
    ),
    '$flatten_list'(T, F1).


map_constraint((A < B), (B:A)).


'$is_a_template_pattern'(A) :-
    ( var(A) ; compound(A), functor(A, F, _), var(F)),
    ip_lookup(template_constraints, TC),
    member_eq(A, TC).

'$is_a_non_template_pattern'(A) :-
    '$is_a_template_pattern'(A), !, fail.
'$is_a_non_template_pattern'(A) :- var(A), !.
'$is_a_non_template_pattern'(A) :-
    compound(A), functor(A, F, _), \+atom(F), !.



watch_debug_write(Clause, Vars, HeadPairs, Rel, I) :-
    watch, !,
    global_state_lookup(watch__,CL),
    (
      %%name_the_vars(Vars),
      prune(HeadPairs,PrunedHeadPairs),
     diff_list(PrunedHeadPairs, Vars, DiffPrunedHeadPairs),
      writeL(["  Call ",CL," unifies clause ",I, "\n     "]),
      displayBV(Vars), 
      display(DiffPrunedHeadPairs),
      (
        '$watch_clauses'(Rel)
      -> 
        do_watch_debug_write_body(Clause)
      ;
        true
      )
    ;
      writeL(["  no (more) proofs using clause ",I,
                       " trying next clause for call ",CL,nl_]), fail
    ).
watch_debug_write(_Clause, _Vars, _HeadPairs, _Rel, _I).

do_watch_debug_write_body(Clause) :-
    collect_vars(Clause, Vars),
    filter(var_name_filter, Vars, UVars),
    '$unify_underscore'(UVars),
    watch_debug_write_body(Clause),
    fail.
do_watch_debug_write_body(_).

do_watch_debug_write_function_body(Clause) :-
    collect_vars(Clause, Vars),
    filter(var_name_filter, Vars, UVars),
    '$unify_underscore'(UVars),
    watch_debug_write_function_body(Clause),
    fail.
do_watch_debug_write_function_body(_).

var_name_filter(X) :- \+ get_var_name(X, _).

watch_debug_write_body((_ :: Test <= Body)) :-
    !,
    writeL(["  Clause body is:\n    :: ", Test, " <=\n"]),
    show_body( Body,6,stdout), nl.
watch_debug_write_body((_ <= Body)) :-
    !,
    write("  Clause body is:\n"),
   show_body(Body,6,stdout),nl.
watch_debug_write_body((_ :: Test ~>> Body)) :-
    !,
    writeL(["  Clause body is:\n    :: ", Test, " ~>>\n"]),
    show_body( Body,6,stdout), nl.
watch_debug_write_body((_ ~>> Body)) :-
    !,
    write("  Clause body is:\n"),
   show_body(Body,6,stdout),nl.
watch_debug_write_body((_ :: Test)) :-
    !,
    writeL(["  Clause body is:  :: ", Test, nl_]).
watch_debug_write_body(_):-
    write("  No clause body\n").  


watch_debug_write_function_body((_ :: Test -> Body)) :-
    !,
    writeL(["\n  Function body is:\n    :: ", Test, " ->\n"]),
    show_body( Body,6,stdout), nl.
watch_debug_write_function_body((_ -> Body)) :-
    !,
    write("\n  Function body is:\n"),
   show_body(Body,6,stdout),nl.

name_the_vars([]).
name_the_vars([(V=A)|Rest]) :-
    (
      var(V), \+ get_var_name(V, _)
    ->
      set_var_name(V, A)
    ;
      true
    ),
    name_the_vars(Rest).


display([]) :- !,     write(" no output\n").
display(Pairs) :-
   write(" output "),
   forall( member((V=Nm),Pairs), (write(Nm=V),write(" ")) ),
   nl. 

displayBV([]) :- !.
displayBV(Pairs) :-
   prune(Pairs, Vars),
   (
     Vars = []
   ->
     write(" no input")
   ;
     write(" input"),
     forall(member((V=Nm),Vars),  (write(" "),write(Nm=V)) )
   ). 


% prune removes binding pairs where the var is still unbound
prune([],[]):-!.
prune([V=Nm|Pairs],[V=Nm|PrunedPairs]) :-
   nonvar(V), !,
   prune(Pairs, PrunedPairs).
prune([_|Pairs],PrunedPairs) :- 
   prune(Pairs, PrunedPairs).

get_clause_i(RelCall, I, Clause, Vars) :-
    global_state_set(x, 0),
    functor(RelCall, F, N),
    functor(CRelCall, F, N),
    '$saved_input_with_vars'(Clause, Vars),
    clause_head(Clause, CRelCall),
    global_state_increment(x, J),
    I = J, !,
    CRelCall = RelCall.

%% Generate the watch version of each function clause
%% Fun is the name of the function and N is the function arity
watch_trans_function_clauses(Fun,N) :-
    functor(FHead, Fun, N),
    N1 is N+1,
    %% The function is compiled to a relation so get the relation clauses
    %% and function clauses
    functor(RelHead, Fun, N1),
    findall(c(Clause), get_clause(RelHead, Clause), New),
    findall(o(Clause, Vars), get_original_clause(FHead, Clause, Vars), Orig),
    atom_concat2(Fun,'_watched',NFun),
    watch_trans_function_clauses_aux(Orig, New, 1,Fun,NFun).

watch_trans_function_clauses_aux([], [], _,_,_).
watch_trans_function_clauses_aux([o(H1,Vars)|T1], [c(H2)|T2], N,Rel,NRel) :-
    N1 is N+1,
    H2 = (Head :- Body),
    (
      H1 = (FHead :: _ -> Expr)
    ;
      H1 = (FHead -> Expr)
    ),
    '$tuple2list'(Body, BodyL),
    append(G1, ['!'|Rest], BodyL),
    (
      G1 = []
    ->
      Test = true
    ;
      '$list2tuple'(G1, Test)
    ),
    '$list2tuple'(Rest, BodyCall),
    ExprCall = (Expr '=?' _),
    freeze_term(ExprCall),
    '$translate_body'(ExprCall, TransExpr),
    thaw_term(TransExpr),
    BodyCall = TransExpr,
    Head =.. [F|Args],
    NRelCall=..[NRel|Args],
    append(InArgs, [Result], Args),
    FHead =.. [F|InArgs],
    add_underscor_to_vars(Vars, UnderVars),  
    assert((NRelCall :-
	   name_the_vars(UnderVars),
           global_state_lookup(watch__,CL),
             watch_debug_function_write(FHead, N, CL, H1, Vars),nl,
           ( 
            Test
           ->
             watch_debug_function_write_succeed(Expr),
             BodyCall,
             watch_debug_function_write_result(FHead, N, Result, CL)
          ;
           watch_debug_function_write_fail(CL), fail
          ))),
    watch_trans_function_clauses_aux(T1, T2, N1,Rel,NRel).

watch_debug_function_write(FHead, N, CL, Clause, _Vars) :-
    watch, !,
    writeL([CL, " : ", FHead, " (rule ", N, ") "]),
     functor(FHead, F, _),
    (
     '$watch_clauses'(F)
    ->
     do_watch_debug_write_function_body(Clause)
    ;
     true
    )
    .
watch_debug_function_write(_FHead, _N, _CL).

watch_debug_function_write_succeed(Expr) :-
    watch, !,
    writeL(["    -> ", Expr, nl_]).
watch_debug_function_write_succeed(_Expr).

watch_debug_function_write_fail(CL) :-
    watch, !,
    writeL([CL, " : Guard failed - trying next clause", nl_]).
watch_debug_function_write_fail(_).


watch_debug_function_write_result(FHead, _N, Result, CL) :-
    watch, !,
    writeL([CL, " : ", FHead, " <- ", Result, nl_]).
watch_debug_function_write_result(_FHead, _N, _Result, _CL).



watch_trans_clauses(Rel,N) :-
    functor(Head, Rel, N),
    findall(c(Clause), get_clause(Head, Clause), New),
    findall(o(Clause, Vars), get_original_clause(Head, Clause, Vars), Orig),
    atom_concat2(Rel,'_watched',NRel),
    watch_trans_clauses_aux(Orig, New, 1,Rel,NRel).

watch_trans_clauses_aux([], [], _,_,_).
watch_trans_clauses_aux([o(H1,Vars)|T1], [c(H2)|T2], N,Rel,NRel) :-
    watch_translate_clause(H1, H1T),
    (
      H1T = (Head :- Body)
    ->
      '$tuple2list'(Body, BodyL),
      '$list2tuple'(BodyL, FBody),
      TH = (Head :- FBody)
    ;
      H1T = Head,
      TH = Head,
      FBody = true
    ), 
    (
      TH = H2
    ->
      true
    ;
      errornl(something_wrong_with_watch_trans(H1, H1T, H2))  %% Just in case
    ),
%    functor(Head, Rel, _N),
%    atom_concat2(Rel,'_watched',NRel),
    Head=..[_ | Args],
    length(Args, Len),
    length(VArgs, Len),
    NRelCall=..[NRel, HeadPairs|VArgs],
    make_unifications(Args, VArgs, Unifs),
 %   errornl(NRelCall),
% HeadPairs arg will be a list of VarName=Var for all the vars in the call
% found by watch__ just before NRel is called. The one for which Var is bound 
% will be printed  out by watch_debug_pairs 

    add_underscor_to_vars(Vars, UnderVars),  
    
    assert((
            NRelCall :-
           name_the_vars(UnderVars),
            rebuild_name_map(HeadPairs, NewHeadPairs),
            rebuild_name_map(UnderVars, NewUnderVars),
            Unifs,
           watch_debug_write(H1, NewUnderVars, NewHeadPairs, Rel, N), FBody
           )),

%    errornl( (NRelCall :- watch_debug_write(H1, Vars, HeadPairs, N), FBody)),
    N1 is N+1,
    watch_trans_clauses_aux(T1, T2, N1,Rel,NRel).
             

add_underscor_to_vars([], []).
add_underscor_to_vars([(V=N)|Vars], [(V= NU)|UnderVars]) :-
    atom_concat(N, '_', NU),
    add_underscor_to_vars(Vars, UnderVars).
    
get_clause(Head, Clause) :-
    clause(Head, Body),
    (
      Body = true
    ->
      Clause = Head
    ;
      Clause = (Head :- Body)
    ).

get_original_clause(Head, Clause, Vars) :-
    '$saved_input_with_vars'(Clause, Vars),
    clause_head(Clause, Head).

watch_translate_clause((H :: Test <= Body), (H :- TransBody)) :- !,
    '$translate_body'(((Test & !) & Body), TransBody).
watch_translate_clause((H  <= Body), (H :- TransBody)) :- !,
    '$translate_body'(Body, TransBody).
watch_translate_clause((H :: Test ~>> Body), (H :- TransBody)) :- !,
    '$translate_body'(((Test & !) & Body), TransBody).
watch_translate_clause((H  ~>> Body), (H :- TransBody)) :- !,
    '$translate_body'(Body, TransBody).
watch_translate_clause((H :: Test), (H :- TransBody)) :- !,
    '$translate_body'((Test & !), TransBody).
watch_translate_clause(H, H).



clause_head((H :: _ -> _), H) :- !.
clause_head((H -> _), H) :- !.
clause_head((H :: _ <= _), H) :- !.
clause_head((H <= _), H) :- !.
clause_head((H :: _ ~>> _), H) :- !.
clause_head((H ~>> _), H) :- !.
clause_head((H :: _), H) :- !.
clause_head(H, H) :- !.

construct([],[]):-!.
construct([V|Vs],[V=NameV|NamePairs]) :-
    get_var_name(V,NameV), !,
    construct(Vs,NamePairs).
construct([_V|Vs],NamePairs) :-
    construct(Vs,NamePairs).

watch_retract(Head, Body) :-
    clause(Head, Body),
    (
      Body = true
    ->
      retract(Head)
    ;
      retract((Head :- Body))
    ).

make_unifications([], [], true).
make_unifications([A|Args], [V|VArgs], ((A=V),Unifs)) :-   
    make_unifications(Args, VArgs, Unifs).

rebuild_name_map([], []).
rebuild_name_map([(V=_)|HeadPairs], [(V=New)|NewHeadPairs]) :-
    get_var_name(V, New),
    rebuild_name_map(HeadPairs, NewHeadPairs).


sorted([]).
sorted([_]) :- !.
sorted([A|R]) :-
    R = [B|C],
    A @< B,
    sorted([B|C]).

'$get_type_info_or_error'(F, Kind, Types, A, RuleInfo) :-
    '$get_ultimate_functor'(A, F),
    '$type_info'(F, Kind, Types, A1, _),
    length(Types, TypeLen),
    functor(A, _, N),
    (
      N = TypeLen
    ->
      A1 = A
    ;
      '$display_error'(already_declared(A, RuleInfo))
    ).


free_vars(Term, Vars) :-
    ground(Term), !, Vars = [].
free_vars(Term, Vars) :-
    var(Term), !,
    Vars = [Term].
free_vars('$forall'(_, _, _), Vars) :-
    !, Vars = [].
free_vars('$forall_actions'(_, _, _), Vars) :-
    !, Vars = [].
free_vars('$exists'(_, _), Vars) :-
    !, Vars = [].
free_vars('$list_constr'(_, _), Vars) :-
    !, Vars = [].
free_vars('$set'(_, _), Vars) :-
    !, Vars = [].
free_vars(List, Vars) :-
    list(List), !,
    free_vars_list(List, Vars).
free_vars(Compound, Vars) :-
    Compound =.. List,
    free_vars_list(List, Vars).

free_vars_list([], []).
free_vars_list([H|T], Vars) :-
    free_vars(H, HV),
    free_vars_list(T, TV),
    union_list(HV, TV, Vars).


'$has_action_query'(QueryList) :-
    member(Q, QueryList),
    '$type_info'(_, action, _, Q, _), !.

'$get_atom_functor'(Term, F) :-
    compound(Term),
    functor(Term, F, _),
    atom(F).

'$check_arg_lens'([], [], _Term, _Clause, _VarNames).
'$check_arg_lens'([A|Args], [T|Types], Term, Clause, VarNames) :- 
    '$tuple_len'(A, AL),
    '$tuple_type_len'(T, TL),
    (
      AL = TL
    ->
      '$check_arg_lens'(Args, Types, Term, Clause, VarNames)
    ;
      '$display_error'(wrong_num_args(Term, Clause, VarNames))
    ).

is_nat(N) :- integer(N), N >= 0.

'$convert_to_types'(T1, T2) :-
    T1 = '$tuple_type'(TT1), !,
    map('$convert_to_types_aux', TT1, TT2),
    T2 = '$tuple_type'(TT2).
'$convert_to_types'(T1, T2) :-
    compound(T1), !,
    errornl('$convert_to_types'(T1)),
    T1 =.. [F|Args],
    map('$convert_to_types_aux', Args, CArgs),
    T2 =.. [F|CArgs]
    .
'$convert_to_types'(T1, T1).

'$convert_to_types_aux'(A,A) :- var(A), !.
'$convert_to_types_aux'([T], '$list_type'(T)) :- !.
'$convert_to_types_aux'('$set_constr'(T), '$set_type'(T)) :- !.
'$convert_to_types_aux'(T1, T2) :-
    compound(T1), !,
    '$convert_to_types'(T1, T2).
'$convert_to_types_aux'(T, T).

'$show_bs' :-
    findall(PX, '$belief_type_info'(PX, _, _), PS),
    sort(PS, PSS),
    member(P, PSS),
    show_belief_clause(P),
    fail.
'$show_bs' :-
    findall(PX, '$percept_type_info'(PX, _, _), PS),
    sort(PS, PSS),
    member(P, PSS),
    show_percept_clause(P),
    fail.
'$show_bs'.


'$real_functor'(C, F, N) :-
    \+compound(C), !, F = C, N = 0.
'$real_functor'(C, F, N) :-
    
    C = F(X), X == '$none_', !,
    N = 0.
'$real_functor'(C, F, N) :-
    functor(C, F, N).

'$constructor_type_arity'(F, N) :-
    '$type_info'(_, defined_type, _, Type, _),
    Type = '$constr_enum_type'(TypeList),
    member(T, TypeList),
    '$real_functor'(T, F, N).
'$constructor_type_arity'(F, N) :-
    '$user_type_info'(_, defined_type, _, '$type_macro'(T), _),
    compound(T),
    '$real_functor'(T, F, N).

'$has_operator'(T) :-
    compound(T),
    functor(T, F, _),
    open_string(write, S),
    writeT_compound(S, T),
    stream_to_string(S, Text),
    string_to_atom(FS, F),
   \+ (string_concat(FS, Rest, Text), string_concat("(", _, Rest)).
    
